SystemOrganization addCategory: 'OrbeonBPMWeb'!

WASeasideBpmIntegration subclass: #WASeasideBpmIntegrationTestForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WASeasideBpmIntegrationTestForm class methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
defaultModel

	^BpmSeasideTempObject new! !

!WASeasideBpmIntegrationTestForm methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
renderContentOn: html

	taskInstance ifNil: [^self renderEditFormOn: html].

	taskInstance isDone ifFalse: [^self renderEditFormOn: html].

	^self renderViewFormOn: html.! !

!WASeasideBpmIntegrationTestForm methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
renderEditFormOn: html

	html form with: [
		html fieldSet with: [
			self renderFormFieldsOn: html.
			html submitButton callback: [self answer]; with: ('Close' translateFor: self session user).
		].
	].! !

!WASeasideBpmIntegrationTestForm methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
renderFormFieldsOn: html

	html legend with: ('New Category' translateFor: self session user).
	html label attributeAt: 'for' put: 'name'; with: ('Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'name'; callback: [:value | model name: value]; value: model name.
	html label attributeAt: 'for' put: 'password'; with: ('Password' translateFor: self session user).
	html colorInput attributeAt: 'id' put: 'password'; callback: [:value | model password: value]; value: model password.! !

!WASeasideBpmIntegrationTestForm methodsFor: 'other' stamp: 'BrunoBB 12/21/2015 12:44'!
renderViewFormOn: html

	html form with: [
		html fieldSet disabled: true; with: [
			self renderFormFieldsOn: html.
		].
		html fieldSet with: [html submitButton callback: [self answer]; with: ('Close' translateFor: self session user).].
	].! !

SEWAFWebLogin subclass: #WAOrbeonProcessLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAOrbeonProcessLogin methodsFor: 'other' stamp: 'BrunoBB 07/09/2016 16:39'!
style

	^'
h1 {margin-left: 20%;}
body {
	margin-bottom: 25px !!important;
	background-color: darkgrey;
}
#flags {
	float: right;
}
#flags img {
	margin-right: 5px;
}
.flag {
	float: left;
}
#login {
	border-radius: 25px;
	padding-top: 20px;
	padding-bottom: 20px;
    width: 50%; 
    margin: 0 auto;
	background-color: lightblue;
}
#login form{
    width:50%;
	background-color: lightblue;
	margin-left: 20%;
}
#login form p{
	color: darkred;
}
#user {
	margin-bottom: 5px;
	display: inline-block;
	width: 80%;
}
#user input {
	border-radius: 15px;
	float: right;
}
#user label {
	float: left;
}
#password {
	display: inline-block;
	width: 80%;
}
#password label {
	float: left;
}
#password input {
	border-radius: 15px;
	float: right;
}
#login-button {
	float: right;
}
#login-button input {
	border-radius: 8px;
	margin-right: -20px;
}'! !

!WAOrbeonProcessLogin methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 07:32'!
tryLogin
	| logedUser loginMode |

	loginMode := self getGemStoneServerConfiguration loginModeFor: 'orbeon-processes-web'.
	(loginMode validateUser: name password: password) ifFalse: [^loginAttempts := loginAttempts + 1].

	logedUser := BpmUser getExistingOrNewUserNamed: name.

	self session user: logedUser.

	"self show: (WAOrbeonFormUser on: logedUser)."

	self show: (WAProcessUserPortal on: logedUser).! !

SEWAFWebObjectComposite subclass: #WAAssignTasksToUsers
	instanceVariableNames: 'tasksBatchedList usersBatchedList selectedTask assignationTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 15:20'!
closeWindow

	assignationTable keysAndValuesDo: [:taskInstance :bpmUser | | assignment availableAssignments |
		availableAssignments := bpmUser getAllAvailableTaskAssignments.
		assignment := taskInstance getAssignment.
		(assignment notNil and: [availableAssignments includes: assignment]) ifTrue: [bpmUser take: assignment].
	].

	mainPanel clearAssignationCompostite.
	mainPanel removeSelectionAndRefreshLateralCollection.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:36'!
getColumnsForTasks

	^OrderedCollection new  
			add: ((SewafReportColumn 
						selector: #getDefinitionName 
						title: ('Task Name' translateFor: self session user)
						onClick: [:each | selectedTask := selectedTask ifNil:[each] ifNotNil: [(selectedTask == each) ifTrue: [nil] ifFalse: [each]]]) 
						beSearchable;
						sortBlock: [:a :b | a getDefinitionName <= b getDefinitionName]);
			add: (SewafReportColumn 
						selector: #state 
						title: ('Task State' translateFor: self session user));
			add: (SewafReportColumn 
						selector: #processId 
						title: ('Process Id' translateFor: self session user));
			yourself! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
initialize

	super initialize.

	assignationTable := Dictionary new.
	tasksBatchedList := SewafBatchedList parentComponent: self.

	tasksBatchedList batchSize: self session user regularListPagingSize;
		navigationCssClass: 'batch-div-bottom';
		isBottomBatch: true.

	usersBatchedList := SewafBatchedList parentComponent: self.

	usersBatchedList batchSize: self session user regularListPagingSize;
		navigationCssClass: 'batch-div-bottom';
		isBottomBatch: true.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
initializeSewafTableForTasks
	| table |

	table := (SewafSelectTableReport parent: self)
		summary: 'Next Tasks';
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: self getColumnsForTasks;
		rowColors: #(white white);
		rowPeriod: 1;
		selectedObject: selectedTask;
		yourself.

	
	^self addSewafTable: table named: 'Tasks'.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 14:06'!
initializeSewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table column|

	column := SewafReportColumn selector: #username title: 'Username'.
	column beSortable; beSearchable; sortBlock: [:a :b | a username <= b username]. 
	table := (SewafBooleanSelectTable parent: self)
		summary: 'Users to Assign';
		backcolor: self session user userOptions getBooleanTableBackcolor;
		buttonLabel: ('Assign' translateFor: self session user);
		booleanSelector: #isSelected:;
		callbackSelector: #selectUser:withValue:;
		columns: (OrderedCollection new add: column; 
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'Users'.! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:17'!
isSelected: aBpmUser

	^(assignationTable at: selectedTask ifAbsent: [^false]) == aBpmUser! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
model: aCollectionOfTasks

	super model: aCollectionOfTasks.

	tasksBatchedList items: aCollectionOfTasks! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:12'!
renderCloseWindowsButtonOn: html

	html form with: [
		html fieldSet with:[
			html legend with: [html strong: ('Close Assignations' translateFor: self session user)].
				html submitButton callback: [self closeWindow]; with: ('Close' translateFor: self session user).
					].
				].! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/04/2016 10:05'!
renderContentOn: html

	html div class: 'assignation-title'; with: [
		html text: 'Assign a User to each Task'].

	html div class: 'default-gray-table float-left'; with: [
		html render: (tasksBatchedList table: self sewafTableForTasks)].

	selectedTask ifNil: [^self].

	usersBatchedList items: selectedTask getGrantedUsers.

	html div class: 'default-gray-table float-left float-left'; with: [
		html render: (usersBatchedList table: self sewafTableForUsers)].

	html div id: 'assignation-close-form'; with: [self renderCloseWindowsButtonOn: html].! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
searchBy: aSymbol

	tasksBatchedList 
		items: (tasksBatchedList items select: [:each |  | columnValue |
					columnValue := each perform: aSymbol.
					(self componentValueAt: 'searchValue') match: columnValue]).! !

!WAAssignTasksToUsers methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 11:00'!
selectedTask
	^selectedTask! !

!WAAssignTasksToUsers methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 11:00'!
selectedTask: newValue
	selectedTask := newValue! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:04'!
selectUser: aBpmUser withValue: aBoolean

	aBoolean 
	ifTrue: [assignationTable at: selectedTask put: aBpmUser] 
	ifFalse: [assignationTable removeKey: selectedTask ifAbsent: []].! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
sewafTableForTasks
	| table |

	table := (self hasTableNamed: 'Tasks') 
		ifTrue: [self getTableNamed: 'Tasks' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForTasks].

	table selectedObject:  selectedTask.

	^table! !

!WAAssignTasksToUsers methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:00'!
sewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (self hasTableNamed: 'Users') 
		ifTrue: [self getTableNamed: 'Users' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForUsers].

	^table! !

!WAAssignTasksToUsers methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 11:00'!
tasksBatchedList
	^tasksBatchedList! !

!WAAssignTasksToUsers methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 11:00'!
tasksBatchedList: newValue
	tasksBatchedList := newValue! !

!WAAssignTasksToUsers methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 11:00'!
usersBatchedList
	^usersBatchedList! !

!WAAssignTasksToUsers methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 11:00'!
usersBatchedList: newValue
	usersBatchedList := newValue! !

SEWAFWebObjectComposite subclass: #WABpmProcessCreationStaticMessage
	instanceVariableNames: 'msgTitle msgText msgData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WABpmProcessCreationStaticMessage methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 09:17'!
initialRequest: aRequest 

	super initialRequest: aRequest.

	msgTitle := aRequest at: 'title' ifAbsent: [^''].
	msgText := aRequest at: 'text' ifAbsent: [^''].
	msgData := aRequest at: 'data' ifAbsent: [^''].! !

!WABpmProcessCreationStaticMessage methodsFor: 'Accessing' stamp: 'BrunoBB 06/21/2016 09:15'!
msgData
	^msgData! !

!WABpmProcessCreationStaticMessage methodsFor: 'Updating' stamp: 'BrunoBB 06/21/2016 09:15'!
msgData: newValue
	msgData := newValue! !

!WABpmProcessCreationStaticMessage methodsFor: 'Accessing' stamp: 'BrunoBB 06/21/2016 09:15'!
msgText
	^msgText! !

!WABpmProcessCreationStaticMessage methodsFor: 'Updating' stamp: 'BrunoBB 06/21/2016 09:15'!
msgText: newValue
	msgText := newValue! !

!WABpmProcessCreationStaticMessage methodsFor: 'Accessing' stamp: 'BrunoBB 06/21/2016 09:15'!
msgTitle
	^msgTitle! !

!WABpmProcessCreationStaticMessage methodsFor: 'Updating' stamp: 'BrunoBB 06/21/2016 09:15'!
msgTitle: newValue
	msgTitle := newValue! !

!WABpmProcessCreationStaticMessage methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 09:52'!
renderContentOn: html

	html div class: 'main-static-msg-div'; with: [
		html div class: 'static-msg-title'; with: [html output: msgTitle].
		html div class: 'static-msg-text'; with: [html output: msgText].
		html div class: 'static-msg-data'; with: [html output: msgData].
	].! !

!WABpmProcessCreationStaticMessage methodsFor: 'other' stamp: 'BrunoBB 06/21/2016 09:54'!
style

^'/* Smart Devices*/
@media (max-width: 800px) {                  
   .smart-hide-width {
      display: none !!important;
   }
}
@media (max-height: 450px) {                  
   .smart-hide-height {
      display: none !!important;
   }
}
/* NEW CSS - REFACTORIZED */
/* START: HTML GENERAL */
body, html, main {
	margin: 0;
	width: 100%;
	height: 100%;
	overflow-y: hidden;
	background-color: #BCBCBC;
}
#screen-all {
	height: 100%;
}
/* END: HTML GENERAL */
.main-static-msg-div {
	margin-left: auto;
	margin-right: auto;
	width: 60%;
	margin-top: 80px;
	font-family: arial;
}
.static-msg-title {
	font-size: 28px;
	margin: 15px;
}
.static-msg-text {
	font-size: 22px;
	margin: 15px;
}
.static-msg-data {
	font-size: 20px;
	margin: 15px;
}'! !

SEWAFWebObjectComposite subclass: #WABpmUnassignedTaskBrowser
	instanceVariableNames: 'unassignedTask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 05/16/2016 15:01'!
gitbookUrl

	^'https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/view_unassigned_tasks.html'! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:44'!
hasSearchValueAt: aString

	^(self searchValueAt: aString)
		ifNotNil: [:each | each notEmpty]
		ifNil: [false]! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 11:14'!
initialize

	super initialize.

	unassignedTask := OrderedCollection new.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:57'!
onApplicationChanged: appName

	searchValues at: 'application' put: appName! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 09:32'!
onRoleChanged: roleName

	searchValues at: 'role' put: roleName.! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 02/08/2016 12:33'!
renderApplicationsComboOn: html

	html label attributeAt: 'for' put: 'applications'; with: ('Applications' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'applications'; 
		list: (#(''), (self session user getApplications collect: [:each | each applicationName])) asSortedCollection;
		callback: [:appName | self onApplicationChanged: appName];
		onChange: 'submit()';
		selected: (searchValues at: 'application' ifAbsent: ['']).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 01/17/2016 15:43'!
renderBpmTaskAssignment: aBpmTaskAssignment on: html 

	"self renderTakeTaskIconOn: html for: eachProcess."

		html div class: 'monitor-list-item-summary'; with: [
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Top Application:' translateFor: self session user)].
				html output: aBpmTaskAssignment applicationName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Process Id:' translateFor: self session user)].
				html output: aBpmTaskAssignment processId.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Process Name:' translateFor: self session user)].
				html output: aBpmTaskAssignment processName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Creation Date:' translateFor: self session user)].
				html output: aBpmTaskAssignment creationDate.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Task Name:' translateFor: self session user)].
				html output: aBpmTaskAssignment taskName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Role:' translateFor: self session user)].
				html output: aBpmTaskAssignment getRoleName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Parent Process:' translateFor: self session user)].
				html output: aBpmTaskAssignment printParentName.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('And Context:' translateFor: self session user)].
				html output: aBpmTaskAssignment printAndContext.].
			html div class: 'monitor-list-item-data'; with: [
				html strong with: [html span: ('Or Context:' translateFor: self session user)].
				html output: aBpmTaskAssignment printOrContext.].
			self renderTakeTaskIconOn: html for: aBpmTaskAssignment.
		].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 08/01/2016 09:53'!
renderContentOn: html
	| heightClass |

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow';
		with: [self renderSearchAreaOn: html.].

	heightClass := mainPanel showMainMenu ifFalse: ['free-tasks-list-hide-top'] ifTrue: ['free-tasks-list-show-top'].

	html div id: 'free-tasks-list'; class: heightClass;
		with: [self renderUnassignedTasksOn: html.].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 10:01'!
renderRolesComboOn: html
	| roles appName |

	appName := searchValues at: 'application' ifAbsent: [''].
	roles := appName isEmpty
		ifFalse: [self session user roles select: [:each | each getApplicationName = appName] thenCollect: [:each | each name]]
		ifTrue: [#()].

	html label attributeAt: 'for' put: 'roles'; with: ('Roles' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'roles'; 
		list: (#(''), roles) asSortedCollection;
		callback: [:roleName | self onRoleChanged: roleName];
		selected: (searchValues at: 'role' ifAbsent: ['']).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 03/12/2016 15:04'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html form with: [ 
		html fieldSet with: [
			html div id: 'top-search-filters'; with: [
				html legend class: 'top-search-legend'; with: ('Search Unassigned Task' translateFor: self session user).
				html div class: 'top-search-div'; with: [self renderApplicationsComboOn: html].
				html div class: 'top-search-div'; with: [self renderRolesComboOn: html].
				html div id: 'top-search-filters-two'; with: [self renderSearchSubmitButtonOn: html].
			].

			"html div id: 'top-search-filters'; with: [
				self renderFilterValuesAndButtonOn: html]."
		].
]! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 16:03'!
renderSearchSubmitButtonOn: html

	html submitButton 
		style: 'margin-top: 35px;';
		callback: [self searchTasksAssignments]; 
		with: ('Search' translateFor: self session user).! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 12:16'!
renderTakeTaskIconOn: html for: aBpmTaskAssignment

	html div class: 'monitor-list-icon'; with: [
		html anchor callback: [self takeTask: aBpmTaskAssignment];
			with: [html image url: (SEWAFIconLibrary / #tasks32Png); 
						altText: 'Take Task';
						title: 'Take Task'].].

	html div class: 'monitor-list-icon-2'; with: [
		html anchor callback: [self takeTaskAndGo: aBpmTaskAssignment];
			with: [html image url: (SEWAFIconLibrary / #applicationarrowright32Png); 
						altText: 'Take Task and Go';
						title: 'Take Task and Go'].].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 11:32'!
renderUnassignedTasksOn: html

	unassignedTask do: [:each | self renderBpmTaskAssignment: each on: html].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:23'!
searchAll

	unassignedTask := self session user getAllAvailableTaskAssignments! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 12/08/2015 12:45'!
searchTasksAssignments
	| matrix |

	((self hasSearchValueAt: 'application') and: [(self hasSearchValueAt: 'role')]) 
	ifTrue: [matrix := BpmRunningTasksMatrix getMatrixForApplicationNamed: (searchValues at: 'application').
				unassignedTask := matrix getAvailableTasksFor: (searchValues at: 'role').]
	ifFalse: [self searchAll].! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 06/13/2016 11:41'!
takeTask: aBpmTaskAssignment
	"The current user take this task and the page is refreshed"

	aBpmTaskAssignment checkIfIsStillAvailableToTake
	ifFalse: [^self searchAll]. 

	self session user take: aBpmTaskAssignment.

	self searchAll! !

!WABpmUnassignedTaskBrowser methodsFor: 'other' stamp: 'BrunoBB 06/13/2016 12:59'!
takeTaskAndGo: aBpmTaskAssignment
	"The current user take this task and then go to the process browser"
	| messages subMenu |

	aBpmTaskAssignment checkIfIsStillAvailableToTake
	ifFalse: [^self searchAll]. 

	self session user take: aBpmTaskAssignment.
	self answer.

	messages := OrderedCollection new.

	subMenu := mainPanel selectSubTabNamed: 'Current Processes' inMenu: 'My Processes' ifNone: [^nil].

	messages 
		add: (MessageSend receiver: mainPanel selector: #showCurrentProcess: argument: (OrderedCollection with: aBpmTaskAssignment));
		add: (MessageSend receiver: mainPanel selector: #selectedLateralItem: argument: aBpmTaskAssignment).

	subMenu addMessagesToSend: messages.! !

!WABpmUnassignedTaskBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/08/2015 09:25'!
unassignedTask
	^unassignedTask! !

!WABpmUnassignedTaskBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/08/2015 09:25'!
unassignedTask: newValue
	unassignedTask := newValue! !

SEWAFWebObjectComposite subclass: #WABpmUserChangePassword
	instanceVariableNames: 'informationComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WABpmUserChangePassword methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 15:55'!
changePassword

	informationComponent ifNil: [informationComponent := SewafInformComponent parent: self].
	(self session user password = (searchValues at: 'current-pwd')) 
	ifFalse: [^informationComponent information: ('Invalid Current Password !!!!!!' translateFor: self session user) color: 'red'].

	((searchValues at: 'repeat-new-pwd') = (searchValues at: 'new-pwd')) 
	ifFalse: [^informationComponent information:  ('New Password and Repeat New Password must be equal !!!!!!' translateFor: self session user) color: 'red'].

	self session user password: (searchValues at: 'new-pwd').

	^informationComponent information: ('Password has been changed !!!!!!' translateFor: self session user) color: 'green'! !

!WABpmUserChangePassword methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 15:55'!
gitbookUrl

	^'https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/fo_change_password.html'! !

!WABpmUserChangePassword methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 15:56'!
renderContentOn: html

	html div id: 'change-password'; class: 'centered-unique-form';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Change Password' translateFor: self session user)].
						html label attributeAt: 'for' put: 'currentPassword'; with: ('Current Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'currentPassword'; callback: [:value | searchValues at: 'current-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword'; with: ('New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword'; callback: [:value | searchValues at: 'new-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword2'; with: ('Repeat New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword2'; callback: [:value | searchValues at: 'repeat-new-pwd' put: value].
						html submitButton callback: [self changePassword]; with: ('Confirm' translateFor: self session user).
						informationComponent ifNotNil: [html render: informationComponent].
					].
				].
		].! !

SEWAFWebObjectComposite subclass: #WABpmUserPreference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WABpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 06/04/2016 10:58'!
gitbookUrl

	^'https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/display_preferences.html'! !

!WABpmUserPreference methodsFor: 'bizagi colors' stamp: 'BrunoBB 08/02/2016 05:59'!
renderBizagiExportBackcolorsOn: html

	html fieldSet with:[
		html legend with: [html strong: ('Color Options' translateFor: self session user)].

		html label attributeAt: 'for' put: 'task.fillColor.done'; with: ('Task Done Fill Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'task.fillColor.done'; 
			value: self session user getTaskDoneFillColor;
			callback: [:value | self session user setTaskDoneFillColor: value].

		html label attributeAt: 'for' put: 'task.borderColor.done'; with: ('Task Done Border Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'task.borderColor.done'; 
			value: self session user getTaskDoneBorderColor;
			callback: [:value | self session user setTaskDoneBorderColor: value].

		html label attributeAt: 'for' put: 'subprocess.fillColor.done'; with: ('Subprocess Done Fill Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'subprocess.fillColor.done'; 
			value: self session user getSubprocessDoneFillColor;
			callback: [:value | self session user setSubprocessDoneFillColor: value].

		html label attributeAt: 'for' put: 'subprocess.borderColor.done'; with: ('Subprocess Done Border Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'subprocess.borderColor.done'; 
			value: self session user getSubprocessDoneBorderColor;
			callback: [:value | self session user setSubprocessDoneBorderColor: value].

		html label attributeAt: 'for' put: 'gateway.fillColor.done'; with: ('Gateway Done Fill Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'gateway.fillColor.done'; 
			value: self session user getGatewayDoneFillColor;
			callback: [:value | self session user setGatewayDoneFillColor: value].

		html label attributeAt: 'for' put: 'gateway.borderColor.done'; with: ('Gateway Done Border Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'gateway.borderColor.done'; 
			value: self session user getGatewayDoneBorderColor;
			callback: [:value | self session user setGatewayDoneBorderColor: value].

		html label attributeAt: 'for' put: 'transition.borderColor.done'; with: ('Transition Done Border Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'transition.borderColor.done'; 
			value: self session user getTransitionDoneBorderColor;
			callback: [:value | self session user setTransitionDoneBorderColor: value].
	].! !

!WABpmUserPreference methodsFor: 'bizagi colors' stamp: 'BrunoBB 08/02/2016 09:03'!
renderBizagiOptionsOn: html

	html div id: 'user-preferences'; class: 'centered-unique-form float-left';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Bizagi Export Colors' translateFor: self session user)].
						self renderBizagiExportBackcolorsOn: html.
						html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).
					].
				].
		].! !

!WABpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 08/02/2016 09:04'!
renderContentOn: html

	html div id: 'user-options'; with: [
		self renderListOptionsOn: html.

		self renderTableOptionsOn: html.

		self renderBizagiOptionsOn: html.
	].! !

!WABpmUserPreference methodsFor: 'list' stamp: 'BrunoBB 03/15/2016 10:38'!
renderDisplayOrbeonFormModeOn: html

	html checkbox 
		class: 'float-left';
		attributeAt: 'id' put: 'viewForm';
		callback: [:value | self session user orbeonWebIsLinked: value]; 
		value: self session user orbeonWebIsLinked.

	html label attributeAt: 'for' put: 'viewForm'; with: ('Display Orbeon Forms Embedded' translateFor: self session user).! !

!WABpmUserPreference methodsFor: 'list' stamp: 'BrunoBB 03/15/2016 10:38'!
renderDisplayPagingSizeOn: html

	html label attributeAt: 'for' put: 'lateralPaging'; with: ('Lateral List Paging Size' translateFor: self session user).
	html textInput 
		style: 'width: 35px;';
		attributeAt: 'id' put: 'lateralPaging'; 
		callback: [:value | self setLateralPagingWith: value];
		value: self session user lateralListPagingSize.

	html label attributeAt: 'for' put: 'regularPaging'; with: ('Regular List Paging Size' translateFor: self session user).
	html textInput 
		style: 'width: 35px; display: block;';
		attributeAt: 'id' put: 'regularPaging'; 
		callback: [:value | self setRegularPagingWith: value];
		value: self session user regularListPagingSize.! !

!WABpmUserPreference methodsFor: 'list' stamp: 'BrunoBB 03/15/2016 10:38'!
renderDisplayTaskBoxModeOn: html

	html checkbox 
		class: 'float-left';
		attributeAt: 'id' put: 'transitionsDisplayModel';
		callback: [:value | self session user setTransitionsDisplayMode: value]; 
		value: self session user transitionDisplayModeIsExpanded.

	html label attributeAt: 'for' put: 'transitionsDisplayModel'; with: ('Display Task Mode - Expanded Box ?' translateFor: self session user).! !

!WABpmUserPreference methodsFor: 'backcolors' stamp: 'BrunoBB 06/11/2016 15:30'!
renderListBackcolorOn: html

	html fieldSet with:[
		html legend with: [html strong: ('Table Report' translateFor: self session user)].
		html label attributeAt: 'for' put: 'tableReport.backcolor'; with: ('Backcolor' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'tableReport.backcolor'; 
			value: self session user userOptions getTableReportBackcolor;
			callback: [:value | self session user userOptions getTableReportBackcolor: value].	 
	].
	html fieldSet with:[
		html legend with: [html strong: ('Select Table' translateFor: self session user)].
		html label attributeAt: 'for' put: 'selectTable.selectedColor'; with: ('Selected Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'selectTable.selectedColor'; 
			value: self session user userOptions getSelectTableSelectedColor;
			callback: [:value | self session user userOptions getSelectTableSelectedColor: value].	
		html label attributeAt: 'for' put: 'selectTable.nonSelectedColor'; with: ('Non Selected Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'selectTable.nonSelectedColor'; 
			value: self session user userOptions getSelectTableNonSelectedColor;
			callback: [:value | self session user userOptions getSelectTableNonSelectedColor: value].
	].
	html fieldSet with:[
		html legend with: [html strong: ('Boolean Table' translateFor: self session user)].
		html label attributeAt: 'for' put: 'booleanTable.backcolor'; with: ('Backcolor' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'booleanTable.backcolor'; 
			value: self session user userOptions getBooleanTableBackcolor;
			callback: [:value | self session user userOptions getBooleanTableBackcolor: value].	
	].! !

!WABpmUserPreference methodsFor: 'list' stamp: 'BrunoBB 08/02/2016 09:01'!
renderListOptionsOn: html

	html div id: 'user-preferences'; class: 'centered-unique-form float-left';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Lists' translateFor: self session user)].
						self renderDisplayOrbeonFormModeOn: html.
						self renderDisplayTaskBoxModeOn: html.
						self renderDisplayPagingSizeOn: html.
						html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).
					].
				].
		].! !

!WABpmUserPreference methodsFor: 'backcolors' stamp: 'BrunoBB 08/02/2016 09:02'!
renderTableOptionsOn: html

	html div id: 'user-preferences'; class: 'centered-unique-form float-left';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Backcolors' translateFor: self session user)].
						self renderListBackcolorOn: html.
						html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).
					].
				].
		].! !

!WABpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:38'!
savePreferences! !

!WABpmUserPreference methodsFor: 'list' stamp: 'BrunoBB 03/15/2016 10:38'!
setLateralPagingWith: value

	self session user lateralListPagingSize: ([(Number fromString: value)] on: Error do: [:err | ^self])! !

!WABpmUserPreference methodsFor: 'list' stamp: 'BrunoBB 03/15/2016 10:38'!
setRegularPagingWith: value

	self session user regularListPagingSize: ([(Number fromString: value)] on: Error do: [:err | ^self])! !

SEWAFWebObjectComposite subclass: #WAOrbeonGrantedTransitionManager
	instanceVariableNames: 'batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAOrbeonGrantedTransitionManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/08/2016 14:33'!
batchedList
	^batchedList! !

!WAOrbeonGrantedTransitionManager methodsFor: 'Updating' stamp: 'BrunoBB 03/08/2016 14:33'!
batchedList: newValue
	batchedList := newValue! !

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 05/30/2016 10:05'!
gitbookUrl

	^'https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/granted_tasks.html'! !

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 07:25'!
initialize

	super initialize.

	batchedList := SewafBatchedList parentComponent: self items: self session user getGrantedTasks.

	batchedList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 14:34'!
renderContentOn: html

	html div id: 'granted-transitions';class: 'default-gray-table';
		with:[html render: (batchedList table: self sewafTableForFormTransitionsDefinitions).].! !

!WAOrbeonGrantedTransitionManager methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 12:48'!
sewafTableForFormTransitionsDefinitions

	^(SewafSelectTableReport summary: 'Artifacts')
		"rows: self session user getGrantedTasks; "
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #applicationName title: 'Application');
						add: (SewafReportColumn selector: #processDefinitionName title: 'Process');
						"add: (SewafReportColumn selector: #startFormName title: 'Required Form');"
						add: (SewafReportColumn selector: #name title: 'Form to Fill');
						add: (SewafReportColumn selector: #printRoleNames title: 'Roles');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

SEWAFWebObjectComposite subclass: #WAOrbeonProcessCategoryManager
	instanceVariableNames: 'selectedCategory batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
categoryColorColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html colorInput 
					attributeAt: 'title' put: ('Color' translateFor: self session user);
					value: each color.] 
			title: 'Color') sortBlock: nil; 
			yourself! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 11:24'!
createNewCategory

	model addToCacheIn: self session user username.

	batchedList add: model.

	model := BpmProcessInstanceCategory new.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
getAllUserCategories

	^BpmProcessInstanceCategory getCategoriesFor: self session user! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 05/16/2016 14:28'!
gitbookUrl

	^'https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/frontoffice_process_categories.html'! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 07:25'!
initialize

	super initialize.

	model := BpmProcessInstanceCategory new.
	batchedList := SewafBatchedList parentComponent: self items: self getAllUserCategories.

	batchedList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
modifyCategory

	selectedCategory removeFromCacheFrom: self session user username.

	selectedCategory name: (self componentValueAt: 'name').
	selectedCategory color: (self componentValueAt: 'color').

	selectedCategory addToCacheIn: self session user username.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 11:25'!
removeCategory

	selectedCategory removeFromCacheFrom: self session user username.

	batchedList remove: selectedCategory.

	selectedCategory := nil.

	model := BpmProcessInstanceCategory new.! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
renderCategoryFormOn: html

	html form with: [
		html fieldSet with: [
			selectedCategory 
				ifNil: [self renderNewCategoryFormOn: html]
				ifNotNil: [self renderSelectedCategoryFormOn: html]
		].
	]! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 11:01'!
renderContentOn: html

	html div class: 'centered-unique-form float-left'; with: [self renderCategoryFormOn: html].

	html div class: 'default-gray-table float-left';
		with:[html render: (batchedList table: self sewafTableForUserCategories).].! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
renderNewCategoryFormOn: html

	html legend with: [html strong: ('New Category' translateFor: self session user)].
	html label attributeAt: 'for' put: 'categotyName'; with: ('Category Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'categotyName'; callback: [:value | model name: value].
	html label attributeAt: 'for' put: 'color'; with: ('Color' translateFor: self session user).
	html colorInput attributeAt: 'id' put: 'color'; callback: [:value | model color: value].
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self createNewCategory]; 
		with: ('Create Category' translateFor: self session user).! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 11:42'!
renderSelectedCategoryFormOn: html

	html legend with: [html strong: ('Selected Category' translateFor: self session user)].
	html label attributeAt: 'for' put: 'categotyName'; with: ('Category Name' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'categotyName';
		value: selectedCategory name;
		callback: [:value | self addValue: value named: 'name'].
	html label attributeAt: 'for' put: 'color'; with: ('Color' translateFor: self session user).
	html colorInput 
		attributeAt: 'id' put: 'color';
		value: selectedCategory color; 
		callback: [:value | self addValue: value named: 'color'].
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self modifyCategory]; 
		with: ('Modify Category' translateFor: self session user).
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self removeCategory]; 
		with: ('Remove Category' translateFor: self session user)! !

!WAOrbeonProcessCategoryManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/08/2016 11:42'!
selectedCategory

   "Return the value of the instance variable 'selectedCategory'."
   ^selectedCategory! !

!WAOrbeonProcessCategoryManager methodsFor: 'Updating' stamp: 'BrunoBB 03/08/2016 11:42'!
selectedCategory: newValue

   "Modify the value of the instance variable 'selectedCategory'."
   selectedCategory := newValue! !

!WAOrbeonProcessCategoryManager methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 12:53'!
sewafTableForUserCategories

	^(SewafSelectTableReport summary: 'User Process Categories')
		"rows: self getAllUserCategories; "
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Category Name' onClick: 
						[:each | (selectedCategory == each) 
									ifTrue: [model := BpmProcessInstanceCategory new. selectedCategory := nil] 
									ifFalse: [model := selectedCategory := each]]);
						add: self categoryColorColumn;
						yourself);
		selectedObject: selectedCategory;
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

SEWAFWebObjectComposite subclass: #WASetUserLanguage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
currentDictionaryName

	^searchValues at: 'selected-language' ifAbsent: ['']! !

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 05/30/2016 10:07'!
gitbookUrl

	^'https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/fo_set_language.html'! !

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
renderContentOn: html

	html div id: 'internationalization'; class: 'centered-unique-form'; with: [
		html form with: [ 
			html fieldSet with: [
			html legend with: [html strong: ('Languages' translateFor: self session user)].
					html label attributeAt: 'for' put: 'language'; with: ('Select Language' translateFor: self session user).
					html select 
						attributeAt: 'id' put: 'language';
						class: '';
						list: (#(''), self getInternationalization currentDictionaries);
						callback: [:value | searchValues at: 'selected-language' put: value];
						selected: self session user currentLanguage.
					html submitButton 
						callback: [self setLanguage]; 
						with: ('Set Language' translateFor: self session user).
				].
		].
	].! !

!WASetUserLanguage methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:41'!
setLanguage

	self session user setLanguage: self currentDictionaryName! !

SewafLateralListComposite subclass: #WAOrbeonNewProcessBrowser
	instanceVariableNames: 'andApplication orApplication andApplications orApplications processInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
addAndApplication

	(andApplication notNil and: [andApplication notEmpty])
	ifTrue: [andApplications add: andApplication].

	andApplication := nil! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
addOrApplication

	(orApplication notNil and: [orApplication notEmpty])
	ifTrue: [orApplications add: orApplication].

	orApplication := nil! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/20/2016 13:35'!
andApplication
	^andApplication! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/20/2016 13:35'!
andApplication: newValue
	andApplication := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/20/2016 13:35'!
andApplications
	^andApplications! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/20/2016 13:35'!
andApplications: newValue
	andApplications := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
createInstanceProcessFor: anBpmProcessDefinition
	"Create a new OrbeonFormProcess based on the definition OrbeonFormProcessDefinition <selectedDefinition> for the user <anOrbeonFormUser>.
	1- Create an OrbeonProcessAssignment.
	2- Create an OrbeonFormProcess.
	3- Associate the Assignment with the Process.
	4- The user <anOrbeonFormUser> take the assignment <anOrbeonProcessAssignment>"

	processInstance := anBpmProcessDefinition createProcessInstance: self session user.

	processInstance 
		andContextApplications: ((andApplications collect: [:each | self getApplicationManagerClass getAnyApplicationNamed: each]) select: [:each | each notNil]);
		orContextApplications: ((orApplications collect: [:each | self getApplicationManagerClass getAnyApplicationNamed: each]) select: [:each | each notNil]).

	processInstance triggerStartEventWith: self session user.

	^processInstance! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
downloadProcessMap

	^self downloadProcessMapOf: self selectedLateralItem! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
downloadProcessMapOf: aBpmProcessDefinition
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: '<?xml version="1.0" encoding="utf-8"?>', String lf,aBpmProcessDefinition xmlString.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmProcessDefinition processName, '.xpdl'); 
                                        yourself)].

	aBpmProcessDefinition subProcess do: [:each | self downloadProcessMapOf: each]! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
getAllFormProcessDefinition

	^self session user getCreationProcesses! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
getCurrentCollection

	searchApplied ifFalse: [^lateralCollection].

	^searchResult! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
getIconNameFormItem

	^#processadd32Png! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
getTextForItem: aLateralListItem

	^aLateralListItem processName! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
getUserApplications

	^self session user getApplications 
		remove: selectedLateralItem application ifAbsent: [];
		yourself! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
gitbookUrl

	^'https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/available_process.html'! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
initialize

	super initialize.

	andApplications := OrderedCollection new.
	orApplications := OrderedCollection new.

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: self session user lateralListPagingSize;
		navigationCssClass: 'batch-div-lateral-top'.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/20/2016 13:35'!
orApplication
	^orApplication! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/20/2016 13:35'!
orApplication: newValue
	orApplication := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/20/2016 13:35'!
orApplications
	^orApplications! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/20/2016 13:35'!
orApplications: newValue
	orApplications := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/20/2016 13:35'!
processInstance
	^processInstance! !

!WAOrbeonNewProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/20/2016 13:35'!
processInstance: newValue
	processInstance := newValue! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
removeAllAnd

	andApplication := nil.
	andApplications := OrderedCollection new.! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
removeAllOr

	orApplication := nil.
	orApplications := OrderedCollection new.! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderAndDetailsOn: html

	html output: 'The application of this process is [', selectedLateralItem applicationName, ']. By adding new applications in the AND Application Context the user has to belong to ALL added application in order to have access to this process.'! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderApplicationComboOn: html

	html label 
		attributeAt: 'for' put: 'application';
		with: ('Application' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'application';
		list: (#(''), (self session user getCreationProcesses collect: [:each | each getApplicationName])) asSet asSortedCollection;
		onChange: 'submit()';
		callback: [:value | self addSearchValue: value named: 'application'.];
		selected: (self searchValueAt: 'application' ifAbsent: ['']).! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderApplicationContextOn: html forApplication: anOrderedCollection withSeparator: aString
	| aStream |

	aStream := PrintStream on: String new.

	anOrderedCollection isEmpty ifTrue: [^''].

	anOrderedCollection do: [:each | aStream nextPutAll:  (each, aString)].

	^html legend: (aStream contents allButLast: 3)! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderContentOn: html
	| widthClass |

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow';
		with: [self renderSearchAreaOn: html.].

	showLateralList ifTrue: [
		html div id: 'lateral-definition-list'; class: 'lateral-left-list'; 
			with: [self renderLateralListOn: html]].

	widthClass := showLateralList ifFalse: ['lateral-right-component-width100'] ifTrue: ['lateral-right-component-width80'].

	html div id: 'process-definition'; class: ('lateral-right-component ', widthClass);
		with: [self renderCompleteItemOn: html].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:49'!
renderItemComponentOn: html
	| inform |

	selectedLateralItem ifNil: [andApplications := OrderedCollection new. ^orApplications := OrderedCollection new].

	self renderNewProcessCommandIconOn: html.

	html div id: 'new-process-options-form'; with: [
		self renderNewProcessAndOptionsOn: html.
		self renderNewProcessOrOptionsOn: html.
	].

	html div id: 'artifact-definitions'; with: [
		selectedLateralItem getOrderedTasks do: [:taskDefinition | 
			html div class: 'artifact-definition'; with: [html output: taskDefinition printNameAndDefinitionType]]
	].

	processInstance ifNil: [^self].

	inform := SewafInformComponent parent: self.
	inform information: (('New Process Created number: <' translateFor: self session user), processInstance id printString, '>') color: 'green'.

	html div id: 'new-process-information'; with: [
		html render: inform.
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderItemDescriptionAditionalDataOn: html! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderItemDescriptionSecondaryDataOn: html

	selectedLateralItem ifNil: [^self].

	html span with: [html strong: ('Version:' translateFor: self session user)].
	html output: selectedLateralItem version.

	html span with: [html strong: ('Application:' translateFor: self session user)].
	html output: selectedLateralItem applicationName.! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderItemDescriptionTitleOn: html

	selectedLateralItem ifNil: [^self].
	
	html output:  ('Create new Instance of [' translateFor: self session user), selectedLateralItem processName, ']'.

	html anchor 
		callback: [self downloadProcessMap]; 
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderLateralItemDetailsOn: html for: aLateralItem! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderNewProcessAndOptionsOn: html

	html div class: 'centered-forms'; with: [
		html form with: [
			html fieldSet with: [
				html label with: 'Application'.
				html select 
					list: (#(' '), ((self getUserApplications collect: [:each | each applicationName]) asSortedCollection difference: andApplications)); 
					title: 'Available Form Applications';
					callback: [:value | andApplication := value].
				html submitButton callback: [self addAndApplication] ; with: ('Add Application' translateFor: self session user).
				html submitButton callback: [self removeAllAnd] ; with: ('Remove All' translateFor: self session user).
			].
			self renderApplicationContextOn: html forApplication: andApplications withSeparator: ' & '.
			self renderAndDetailsOn: html.
		].
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderNewProcessCommandIconOn: html

	html div class: 'centered-forms'; with: [
		self selectedLateralItem ifNotNil: [self renderNewProcessIconOn: html for: self selectedLateralItem].
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderNewProcessIconOn: html for: aBpmProcessDefinition

	html anchor callback: [self createInstanceProcessFor: aBpmProcessDefinition];
		with: [html image url: (SEWAFIconLibrary / #processadd32Png); 
					altText: ('Create New Process' translateFor: self session user);
					title: ('Create New Process' translateFor: self session user)].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderNewProcessOrOptionsOn: html

	html div class: 'centered-forms'; with: [
		html form with: [
			html fieldSet with: [
				html label with: 'Application'.
				html select 
					list: (#(' '), ((self getUserApplications collect: [:each | each applicationName]) asSortedCollection difference: orApplications)); 
					title: 'Available Form Applications';
					callback: [:value | orApplication := value].
				html submitButton callback: [self addOrApplication] ; with: ('Add Application' translateFor: self session user).
				html submitButton callback: [self removeAllOr] ; with: ('Remove All' translateFor: self session user).
			].
			self renderApplicationContextOn: html forApplication: orApplications withSeparator: ' | '.
			self renderOrDetailsOn: html.
		].
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderOrDetailsOn: html

	html output: 'The application of this process is [', selectedLateralItem applicationName, ']. By adding new applications in the OR Application Context the user has to belong to ANY added application in order to have access to this process.'! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderProcessDefinitionOn: html for: eachProcess

	html div class: 'unique-wide-list-item-summary'; with: [
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Id:' translateFor: self session user)].
			html output: eachProcess processId.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Process Name:' translateFor: self session user)].
			html output: eachProcess processName.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Version:' translateFor: self session user)].
			html output: eachProcess version.].
		html div class: 'unique-wide-list-item-data'; with: [
			html strong with: [html span: ('Application:' translateFor: self session user)].
			html output: eachProcess applicationName.].
	].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html div id: 'top-search-area'; 
		with: [html form with: [ 
					html fieldSet with: [
						html legend class: 'top-search-legend'; with: ('Search Process' translateFor: self session user).
						html div class: 'top-search-div'; with: [self renderApplicationComboOn: html].
						self renderSearchSubmitButtonOn: html].
					].
				].! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
renderSearchSubmitButtonOn: html

	html div id: 'top-search-filters-one';
		style: 'margin-top: 20px;';
		with: [
			html submitButton 
				callback: [self searchCreationProcesses]; 
				with: ('Search' translateFor: self session user).
		]! !

!WAOrbeonNewProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 13:35'!
searchCreationProcesses
	| application |

	searchApplied := true.

	searchResult :=  (self hasSearchValueAt: 'application') 
					ifFalse: [self session user getCreationProcesses]
					ifTrue: [application := AbstractApplication getAnyApplicationNamed: (self searchValueAt: 'application') ifNone: [^nil].
								(self session user getCreationProcesses select: [:each | each application == application])].

	batchedList items: searchResult! !

SewafLateralListComposite subclass: #WAOrbeonProcessBrowser
	instanceVariableNames: 'seasideK mode categories transitionsHeight assignationComposite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

WAOrbeonProcessBrowser subclass: #WAEmbeddedProcessBrowser
	instanceVariableNames: 'orbeonFrame orbeonIsOnPage isEditMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 15:22'!
hasIFrame

	^orbeonFrame notNil! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/02/2015 15:22'!
initialize

	super initialize.

	orbeonIsOnPage := false.
	isEditMode := false.! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
isEditMode
	^isEditMode! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
isEditMode: newValue
	isEditMode := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'orbeon links' stamp: 'BrunoBB 12/11/2015 08:48'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	orbeonFrame := self getUrlFor: aBpmArtifactInstance with: uuid.! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonFrame
	^orbeonFrame! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonFrame: newValue
	orbeonFrame := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonIsOnPage
	^orbeonIsOnPage! !

!WAEmbeddedProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/02/2015 15:22'!
orbeonIsOnPage: newValue
	orbeonIsOnPage := newValue! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 07/01/2015 12:32'!
renderContentOn: html
	| widthClass |

	seasideK := self requestContext request at: '_k' ifAbsent: ['error'].

	self hasIFrame ifFalse: [^super renderContentOn: html].

	html div id: 'top-search-area'; with: [self renderSearchAreaOn: html.].

	showLateralList ifTrue: [
		html div id: 'lateral-assignment-list'; with: [self renderLateralListOn: html]].

	widthClass := showLateralList ifFalse: ['process-assignment-width100'] ifTrue: ['process-assignment-width80'].
	
	html div id: 'process-assignment'; class: widthClass;
		with: [self renderEmbeddedProcessAssignmentOn: html.
				self renderContentWithFrameOn: html].! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 14:59'!
renderContentWithFrameOn: html

	html div id: 'close-form-frame'; 
		with: [html anchor callback: [orbeonFrame := nil]; 
			with: [html image url: (SEWAFIconLibrary / #symboldeleteiconPng);
													title: ('Close Form' translateFor: self session user);
													altText: ('Close Form' translateFor: self session user)]].
	html div id: 'orbeon-form-frame'; 
		with: [html div id: 'orbeon-form'; with: [html iframe url: orbeonFrame]].! !

!WAEmbeddedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 14:58'!
renderEmbeddedProcessAssignmentOn: html

	selectedLateralItem ifNil: [^self].

	html div id: 'process-assignment-description'; 
		with: [self renderItemDescriptionOn: html.].

	html horizontalRule.! !

WAOrbeonProcessBrowser subclass: #WALinkedProcessBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WALinkedProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 12/11/2015 08:49'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	^self requestContext redirectTo: (self getUrlFor: aBpmArtifactInstance with: uuid).! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
assignationComposite
	^assignationComposite! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
assignationComposite: newValue
	assignationComposite := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
buildEditUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to EDIT the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/edit/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
buildNewUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to NEW Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP, '/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition, '/new?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
buildPDFUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to PDF the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/pdf/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
buildViewUrlFor: aBpmArtifactInstance with: anUUID
	"Answer a string Link to VIEW the Orbeon Form associated with the transition <aBpmArtifactInstance> using the security token <anUUID>"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName.

	^self getOrbeonWebServerConfiguration orbeonIP,'/orbeon/fr/', aBpmArtifactInstance applicationName ,'/',formDefinition,'/view/', aBpmArtifactInstance getOrbeonFormId,'?token=', anUUID,'&s=', self session key,'&k=', seasideK, '&oop=', aBpmArtifactInstance asOop printString, '&oop2=', selectedLateralItem asOop printString! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
categories
	^categories! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
categories: newValue
	categories := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 11:03'!
clearAssignationCompostite

	assignationComposite := nil! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
closeAndSendForm: aBpmArtifactInstance
	"After filling the form the user has clicked on close and send.
	The form can not be edited again."

	self session user finalizeAssignment: selectedLateralItem.

	self removeSelectionAndRefreshLateralCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 15:18'!
closeSendAndSelectUsers: aBpmArtifactInstance
	| assignmentFinalization currentActivities newTasks |

"	self inform: 'Not Implemented Yet'."
	currentActivities := OrderedCollection withAll: (selectedLateralItem process currentActivities asArray remove: aBpmArtifactInstance; yourself).

	assignmentFinalization := self session user finalizeAssignment: selectedLateralItem.

	newTasks := selectedLateralItem process currentActivities asArray removeAll: currentActivities; yourself.

	newTasks ifEmpty: [^self].

	assignationComposite := WAAssignTasksToUsers parent: self on: newTasks.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
closeSendAndTakeNextForms: aBpmArtifactInstance
	"After filling the form the user has clicked on close and send.
	The form can not be edited again."

	self session user finalizeAssignment: selectedLateralItem takeNext: true.

	self removeSelectionAndRefreshLateralCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
collapseIconFor: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #collapsed])
	ifTrue: [^#circledown16Png].

	^#circleup16Png! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
collapseTitleFor: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #expanded]) 
	ifFalse: [^'Expand' translateFor: self session user].

	^'Collapse' translateFor: self session user! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
createOrbeonLinkOn: html for: aBpmArtifactInstance

	"when a role has more than one active task with permission --> the edit and new icon is showed only with the properly assignment
 (aBpmArtifactInstance == selectedLateralItem task)"
	(((aBpmArtifactInstance == selectedLateralItem task) and: [aBpmArtifactInstance isDone not]) or: [aBpmArtifactInstance isDone])
	ifTrue: [
		html anchor callback: [self linkToOrbeonFormFor: aBpmArtifactInstance]; 
							with: [html image url: (SEWAFIconLibrary / (self iconFor: aBpmArtifactInstance));
														title: (self imageTitleFor: aBpmArtifactInstance);
														altText: (self imageTitleFor: aBpmArtifactInstance)].
	].
	(aBpmArtifactInstance hasForm and:[(aBpmArtifactInstance isGrantedUser: self session user)])
	ifTrue: [ html anchor callback: [self linkToOrbeonPdfFor: aBpmArtifactInstance];
							target: '_blank'; "open the PDF in a new tab or page"
							with: [html image url: (SEWAFIconLibrary / #pdf32Png);
														title: ('View PDF' translateFor: self session user);
														altText: ('View PDF' translateFor: self session user)].
	]
	"if the transition is done and has expected results --> we render an icon to show results summary"

"	(anOrbeonFormTransition isDone and:[anOrbeonFormTransition hasExpectedResult])
	ifTrue: [self renderExpectedResultIcon: html for: anOrbeonFormTransition]"! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
createSeasideLinkOn: html for: aBpmArtifactInstance

	html anchor callback: [self linkToSeasideComponentFor: aBpmArtifactInstance]; 
						with: [html image url: (SEWAFIconLibrary / (self iconFor: aBpmArtifactInstance));
													title: (self imageTitleFor: aBpmArtifactInstance);
													altText: (self imageTitleFor: aBpmArtifactInstance)].! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 08/03/2016 05:32'!
createZipFileFor: aBpmProcessInstance withName: pathFile
	| file archive |

	archive := ZipArchive new.

	file := GsFile open: pathFile mode: 'wb' onClient: false.

	self storeProcessDefinition: aBpmProcessInstance onZip: archive withFile: file.

	file close.! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
displayModeFor: aBpmArtifactInstance

	^transitionsHeight at: aBpmArtifactInstance ifAbsent: [#expanded]! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 08/03/2016 05:32'!
downloadProcessMap

	self selectedLateralItem process getTopProcess hasSubprocesses
	ifTrue: [self downloadZipProcessMapOf: self selectedLateralItem] "generate a ZIP with all subprocesses"
	ifFalse: [self downloadProcessMapOf: self selectedLateralItem]. "generate a XPDL"! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 08/03/2016 05:32'!
downloadProcessMapOf: aBpmTaskAssignment
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: self xmlHeader, String lf, (aBpmTaskAssignment process generateProcessMapFor: self session user) prettyPrinted.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmTaskAssignment processName, '.xpdl'); 
                                        yourself)].! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 08/03/2016 05:32'!
downloadZipProcessMapOf: aBpmTaskAssignment
	| contents fileStream fileName |

	fileName := '/tmp/', aBpmTaskAssignment process getTopProcess processName, Lag1MwcRandom new integer printString, '.zip'.

	self createZipFileFor: aBpmTaskAssignment process getTopProcess withName: fileName.

	fileStream := FileStream read: fileName.

	contents := fileStream contents.

	self requestContext respond: [:response | 
        response document: ((contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/octet-stream'; 
                                        fileName: fileName; 
                                        yourself)].! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
filterProcessDefinitionByCategory: aBpmProcessInstanceCategory

	searchApplied := true.
	searchResult := self getIterationCollection select: [:each | aBpmProcessInstanceCategory includes: each]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
freeSelectedAssignment

	selectedLateralItem isTaken 
	ifTrue: [self session user untake: selectedLateralItem.].

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	searchResult remove: selectedLateralItem ifAbsent: [].

	selectedLateralItem := nil.

	self getCurrentCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getAllAssignmentsFor: procName in: appName
	"Answer a collection of <OrbeonProcessAssignment> for the process named <procName> in application <appName>"
	| selectBlock |

	appName isEmpty ifTrue: [^searchResult := self getIterationCollection].

	selectBlock := (procName = self viewAllText)
		ifTrue: [[:each | each applicationName = appName]]
		ifFalse: [[:each | each applicationName = appName and: [each processName = procName]]].

	searchResult := self getIterationCollection select: selectBlock! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
getAllTasks

	selectedLateralItem ifNil: [^#()].

	self modeIsFinishedTasks ifFalse: [^selectedLateralItem getExecutedArtifacts, selectedLateralItem getRunningArtifacts].

	^OrderedCollection with: selectedLateralItem task! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 08/03/2016 05:32'!
getCurrentCollection

	searchApplied ifFalse: [^lateralCollection].

	^searchResult! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getFormDefinitionList
	"The receiver answer a collection with all form definitions of the selected process type at <searchValues> 'process-type'"
	| procDef |

	procDef := self getSelectedProcessDefinitionOrNil.

	procDef ifNil: [^#()].

	^self viewAllArray, procDef getTaskNames asSet asSortedCollection! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getFormFieldList
	"The receiver answer a collection with all field names (removing layer mandatory fields -s,k,oop,uuid-) of the form type in <searchValues> 'form-type' "
	| selectedProcess selectedTask fieldList |

	selectedProcess := self getSelectedProcessDefinitionOrNil.
	selectedProcess ifNil: [^#()].
	selectedTask := self getSelectedTaskOrNil.
	selectedTask ifNil: [^#()].

	fieldList := #(''), (selectedProcess getFieldNamesOfTask: selectedTask name).

	^(fieldList remove: 'assignmentOop[s]' ifAbsent: []; 
			remove: 'k[s]' ifAbsent: []; 
			remove: 's[s]' ifAbsent: [];
			remove: 'oop[s]' ifAbsent: [];
			remove: 'uuid[s]' ifAbsent: [];
			yourself) asSortedCollection! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 08/03/2016 05:32'!
getIconNameFormItem 

	^#pageprocess32Png! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getIterationCollection
	"Get the iteration collection where the search process will iterate over to find a specific element"

	self modeIsFinishedTasks ifTrue: [^self session user getFinishedAssigments asArray].

	^lateralCollection! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getSelectedApplicationOrNil

	^self getApplicationManagerClass getAnyApplicationNamed: (self searchValueAt: 'application' ifAbsent: '') ifNone: [nil]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getSelectedProcessDefinitionOrNil
	| definitions |

	definitions := BpmProcessDefinition 
							getAllProcessesNamed: (self searchValueAt: 'process-type' ifAbsent: ['']) 
							in: (self searchValueAt: 'application' ifAbsent: ['']).

	^definitions ifNotEmpty: [definitions last] ifEmpty: [nil]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
getSelectedTaskOrNil
	"The receiver answer the current selected task (orbeon form definition or st model) or nil"

	^self getSelectedProcessDefinitionOrNil
		ifNil: [nil]
		ifNotNil: [:procDefinition | procDefinition getTaskNamed: (self searchValueAt: 'form-type' ifAbsent: ['']) ifNone: [nil]]! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 08/03/2016 05:32'!
getTextForItem: aLateralListItem

	^aLateralListItem processName! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
getUrlFor: aBpmArtifactInstance with: anUUID
	"Generate an url link to Java Orbeon application with context execution parameters (that are stored as hidden in the Java Orbeon Form) so the Java Application can return back to this web page with an updated domain model"
	| formDefinition |

	formDefinition := aBpmArtifactInstance getDefinitionName. "name of the form to link"
	^aBpmArtifactInstance hasForm "is a new or an edited form ?"
		ifFalse: [(aBpmArtifactInstance isGrantedUser: self session user) "has permissions ?"
					ifTrue: [self buildNewUrlFor: aBpmArtifactInstance with: anUUID]] "Orbeon NEW link"
		ifTrue: [(aBpmArtifactInstance isDone 
						or:[(aBpmArtifactInstance isGrantedUser: self session user) not 
						or: [(aBpmArtifactInstance innerTaskHasBeenFinalizedBy: self session user) and: [self modeIsFinishedTasks]]])
			ifFalse: [self buildEditUrlFor: aBpmArtifactInstance with: anUUID] "Orbeon EDIT link"
			ifTrue: [self buildViewUrlFor: aBpmArtifactInstance with: anUUID]] "Orbeon VIEW link"! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
gitbookUrl

	^self modeIsFinishedTasks
	ifTrue: ['https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/finished_processes.html']
	ifFalse: ['https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/current_processes.html']! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
iconFor: aBpmArtifactInstance

	aBpmArtifactInstance isCreated ifFalse: [^#pageprocess32Png].

	(aBpmArtifactInstance hasPerformers and: [aBpmArtifactInstance innerTaskHasBeenFinalizedBy: self session user])
	ifTrue: [^#processacceptPng].

	aBpmArtifactInstance isDone ifTrue: [^#processacceptPng].

	aBpmArtifactInstance isProcessing ifTrue: [^#documentediticonPng].
"	aBpmArtifactInstance isPaused ifTrue: [^#stopwatchpausePng].
	aBpmArtifactInstance isDelayed ifTrue: [^#clockPng].
	aBpmArtifactInstance isPending ifTrue: [^#aquastrippedfolderclockPng]."

	^#documentediticonPng! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
imageTitleFor: aBpmArtifactInstance

	aBpmArtifactInstance isCreated ifFalse: [^'Create Task' translateFor: self session user].
	aBpmArtifactInstance isDone ifTrue:[^'Finished Task' translateFor: self session user].
	aBpmArtifactInstance isProcessing ifTrue: [^'Edit Task' translateFor: self session user].
"	aBpmArtifactInstance isPaused ifTrue: [^'Paused' translateFor: self session user].
	aBpmArtifactInstance isDelayed ifTrue: [^'Delayed' translateFor: self session user].
	aBpmArtifactInstance isPending ifTrue: [^'Pending' translateFor: self session user]."

	^'Undefined' translateFor: self session user! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
initialize

	super initialize.

	searchAvailable := false.
	mode := #normal.
	categories := OrderedCollection new.
	transitionsHeight := Dictionary new.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: self session user lateralListPagingSize;
		navigationCssClass: 'batch-div-lateral-top'.! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
isRangeSearch

	^(self searchValueAt: 'field-value-2' ifAbsent: [^false]) notNil! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
linkToOrbeonFormFor: aBpmArtifactInstance
	"The receiver gives the control to Orbeon Java application."

	self subclassResponsibility! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
linkToOrbeonPdfFor: aBpmArtifactInstance
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: aBpmArtifactInstance 
					for: self session user.

	^self requestContext redirectTo: (self buildPDFUrlFor: aBpmArtifactInstance with: uuid)! !

!WAOrbeonProcessBrowser methodsFor: 'link to components' stamp: 'BrunoBB 08/03/2016 05:32'!
linkToSeasideComponentFor: aBpmSeasideTaskInstance
  "The receiver gives the control to the component of task <aBpmSeasideTaskInstance>."
  | seasideModel |

  aBpmSeasideTaskInstance
    externalObject:
      (aBpmSeasideTaskInstance hasForm
        ifTrue: [aBpmSeasideTaskInstance externalObject]
        ifFalse: [aBpmSeasideTaskInstance getObjectModel]).

  seasideModel := aBpmSeasideTaskInstance externalObject.

  self show: (aBpmSeasideTaskInstance getComponentClass 
						newOn: seasideModel 
						task: aBpmSeasideTaskInstance 
						assignment: selectedLateralItem)! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
mode
	^mode! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
mode: newValue
	"Set the mode of the receiver (#finished or #normal). 
	normal - is when lateral list is composed with current pending assignments.
	finished - is when lateral list is composed with finished assignments.
	If <mode> is different from <newValue> --> the sub menu has changed the <selectedLateralItem> must be reseted"

	(mode == newValue) ifFalse: [selectedLateralItem := nil].

	mode := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
modeIsFinishedTasks

	^mode = #finished! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
onProcessCategoryClicked: aProcessInstanceUserCategory

	self hasSelectedLateralItem ifFalse: [^self filterProcessDefinitionByCategory: aProcessInstanceUserCategory].

	(aProcessInstanceUserCategory includes: selectedLateralItem)
	ifTrue: [aProcessInstanceUserCategory remove: selectedLateralItem]
	ifFalse: [aProcessInstanceUserCategory add: selectedLateralItem]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
registerProcessType: value

	self addSearchValue: value named: 'process-type'.
	self removeSearchValueNamed: 'form-type'.
	self removeSearchValueNamed: 'field-name'.
	self removeSearchValueNamed: 'field-value'.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
removeSelectionAndRefreshLateralCollection

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	searchResult remove: selectedLateralItem ifAbsent: [].

	selectedLateralItem := nil.

	self getCurrentCollection.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderApplicationComboOn: html

	html label 
		attributeAt: 'for' put: 'application';
		with: ('Application' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'application';
		list: (#(''), (self session user getApplications collect: [:each | each applicationName])) asSet asSortedCollection;
		onChange: 'submit()';
		callback: [:value | self addSearchValue: value named: 'application'.];
		selected: (self searchValueAt: 'application' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderButtonWithoutFilters

	^((self hasSearchValueAt: 'field-name') and:[self hasSearchValueAt: 'form-type']) not! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCategoriesListOn: html

	categories do: [:each | 
		html anchor callback: [self onProcessCategoryClicked: each]; 
			class: 'category-label';
			style: 'background-color:', each color;
			with: [html output: each name]].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCloseAndSendFormOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance isDone ifTrue: [^self].

	aBpmArtifactInstance isCreated ifFalse: [^self].
	(aBpmArtifactInstance isGrantedUser: self session user) ifFalse: [^self].

	"the task <aBpmArtifactInstance> is different from the current selected assignment"
	(aBpmArtifactInstance == selectedLateralItem task) ifFalse: [^self].

	(aBpmArtifactInstance canCloseAndSend or: [(aBpmArtifactInstance hasPerformers and: [aBpmArtifactInstance canCloseAndSendPerformer: self session user])])
		ifTrue: [self renderCloseAndSendIconOn: html for: aBpmArtifactInstance
		]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCloseAndSendIconOn: html for: aBpmArtifactInstance
	| symbolIcon |

	symbolIcon := aBpmArtifactInstance isFinishedByPerformers ifFalse: [#tasksicon32Png] ifTrue: [#emailsendiconPng].

	html div class: 'float-right'; with: [
		html anchor callback: [self closeAndSendForm: aBpmArtifactInstance]; 
									with: [html image url: (SEWAFIconLibrary / symbolIcon); 
															title: ('Close & Send Form' translateFor: self session user);
															altText: ('Close & Send Form' translateFor: self session user)].

		html anchor callback: [self closeSendAndTakeNextForms: aBpmArtifactInstance]; 
									with: [html image url: (SEWAFIconLibrary / #applicationarrowright32Png); 
															title: ('Close, Send & Take Next Forms' translateFor: self session user);
															altText: ('Close, Send & Take Next Forms' translateFor: self session user)].

		html anchor callback: [self closeSendAndSelectUsers: aBpmArtifactInstance]; 
									with: [html image url: (SEWAFIconLibrary / #userarrowright32Png); 
															title: ('Close, Send & Select Users' translateFor: self session user);
															altText: ('Close, Send & Select Users' translateFor: self session user)].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCompleteItemOn: html
	| heightClass |

	selectedLateralItem ifNil: [^self].

	html div id: 'item-complete-description'; class: 'lateral-right-component-description';
		with: [self renderItemDescriptionOn: html.].

	html horizontalRule.

	heightClass := mainPanel showMainMenu 
							ifFalse: ['item-customized-component-hide-top'] 
							ifTrue: ['item-customized-component-show-top'].

	html div id: 'item-customized-component'; class: heightClass; 
		with: [self renderItemComponentOn: html.].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
renderContentOn: html

	seasideK := self session requestContext request at: '_k' ifAbsent: ['error'].

	super renderContentOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
renderCustomItemElementOn: html forItem: aBpmTaskAssignment

	(self session user getProcessInstanceCategoriesFor: aBpmTaskAssignment) do: [:each | 
		html div class: 'category-circle'; style: 'background-color: ', each color;
			with: [html output: each name first].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderFilterFields

	^(self hasSearchValueAt: 'form-type') 
		and: [(self hasSearchValueAt: 'process-type')  
		and:[(self hasSearchValueAt: 'field-name') 
		and:[self getSelectedProcessDefinitionOrNil notNil]]]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderFilterValuesAndButtonOn: html
	| processName procDef formType fieldName fieldType |

	formType := self searchValueAt: 'form-type'.
	processName := self searchValueAt: 'process-type'.
	fieldName := self searchValueAt: 'field-name'.

	procDef := self getSelectedProcessDefinitionOrNil.

	fieldType := (procDef getTypeOfFieldNamed: fieldName) ifNil: [^self renderSearchSubmitButtonOn: html]  ifNotNil: [:type | type].

	((OrderedCollection with: String with: Boolean) includes: fieldType) ifTrue: [^html div id: 'top-search-filters-one'; with: [self renderOneFilterOn: html]].

	^html div id: 'top-search-filters-two'; with: [self renderTwoFitersOn: html].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderFormDataOn: html for: aBpmActivityInstance

	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('User' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance getUserName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('State' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (aBpmActivityInstance printState translateFor: self session user)]].
"	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Previous Form' translateFor: self session user)].
		html strong with: [html output  with: (aBpmActivityInstance getDefinitionName translateFor: self session user)]]."
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Form to Fill' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance getDefinitionName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Creation Time' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmActivityInstance creationTime]].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderFormDefinitionComboOn: html

	html label 
		attributeAt: 'for' put: 'formDefinitions';
		with: ('Form' translateFor: self session user).

	html select "Form Definition List" 
		attributeAt: 'id' put: 'formDefinitions';
		class: 'search-section-width-200';
		list: ((self hasSearchValueAt: 'process-type') 
				ifFalse: [#()] 
				ifTrue: [self getFormDefinitionList]);
		onChange: 'submit()';
		callback: [:value | self addSearchValue: value named: 'form-type'];
		selected: (self searchValueAt: 'form-type' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderFormFieldComboOn: html

	html label 
		attributeAt: 'for' put: 'formFields';
		with: ('Field' translateFor: self session user).

	html select "Field Definition List" 
		attributeAt: 'id' put: 'formFields';
		class: 'search-section-width-200';
		list: self getFormFieldList;
		onChange: 'submit()';
		callback: [:value | self addSearchValue: value named: 'field-name'];
		selected: (self searchValueAt: 'field-name' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/04/2016 08:40'!
renderItemComponentOn: html
	| heightClass |

	assignationComposite 
		ifNotNil: [html render: assignationComposite]
		ifNil: [
			self getAllTasks do:[:eachArtifact | | cssClass |
				cssClass := eachArtifact isTask 
					ifFalse: ['process-transition-gateway']
					ifTrue: [eachArtifact isDone
						ifTrue: ['process-transition-finished']
						ifFalse: ['process-transition-running']].

				heightClass := ((transitionsHeight at: eachArtifact ifAbsent: [#expanded]) = #expanded) 
										ifTrue: ['process-transition-expanded'] 
										ifFalse: ['process-transition-collapsed'].

				html div class: (cssClass, ' ', heightClass); with: [
					self renderTransitionDataOn: html for: eachArtifact].
			]. 
		].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderItemDescriptionAditionalDataOn: html

	html span with: [html strong: ('Assigned Date:' translateFor: self session user)].
	html output: selectedLateralItem printAssignmentDate.
	html span: [html strong: ('Current Forms:' translateFor: self session user)].
	html output: selectedLateralItem printProcessRunningArtifacts.
	html span: [html strong: ('Process Creator:' translateFor: self session user)].
	html output: selectedLateralItem printCreatorName.
	html span: [html strong: ('Can Unassign:' translateFor: self session user)]. 
	html output: (selectedLateralItem canUnassign printString translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderItemDescriptionSecondaryDataOn: html

	html span with: [html strong: ('Application:' translateFor: self session user)].
	html output: selectedLateralItem applicationName.
	html span with: [html strong: ('Process Id:' translateFor: self session user)].
	html output: selectedLateralItem processId.
	html span: [html strong: ('Version:' translateFor: self session user)]. 
	html output: selectedLateralItem version.
	html span: [html strong: ('Process State:' translateFor: self session user)].
	html output: (selectedLateralItem printProcessState translateFor: self session user).! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderItemDescriptionTitleOn: html
	"The receiver render the summary of the object selected on the Lateral List "

	html output:  selectedLateralItem processName. "process name"
	selectedLateralItem isInCorruptedState 
	ifTrue: [html span with: [html strong: ('(Corrupted)' translateFor: self session user)]].

	selectedLateralItem hasFinalized
	ifFalse: [
		html anchor 
			callback: [self freeSelectedAssignment]; 
			with: [html image url: (SEWAFIconLibrary / #gointo24Png); 
						title: ('Free Process' translateFor: self session user);
						altText: ('Free Process' translateFor: self session user)]].

	html anchor 
		callback: [self downloadProcessMap]; 
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WAOrbeonProcessBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 08/03/2016 05:32'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem processId].
	html strong with: [html output: aLateralItem printAssignmentDate].
	html strong with: [html output: aLateralItem printRunningArtifacts]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderOneFilterOn: html

	self addSearchValue: nil named: 'field-value-2'. "clean the second value --> is not going to be used"

	html label 
		attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; with: ('Field Value' translateFor: self session user).

	html textInput 
		attributeAt: 'id' put: 'filterOne';
		callback: [:value | self addSearchValue: value named: 'field-value'];
		with: (self searchValueAt: 'field-value' ifAbsent: ['']).

	self renderSearchSubmitButtonOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderOrbeonLinkIconOn: html for: aBpmTaskInstance

	"a granted user with edit permission"
	(aBpmTaskInstance isGrantedUser: self session user) 
	ifTrue: [^self createOrbeonLinkOn: html for: aBpmTaskInstance].
	"a user that has edit permission in other part of the process and does NOT has it this Transition, is granted to READ. 
	If the Form has not been created then there is NOTHING to view"
	((aBpmTaskInstance isGrantedUser: self session user) and: [aBpmTaskInstance hasForm]) 
	ifTrue: [^self createOrbeonLinkOn: html for: aBpmTaskInstance].

	"self createLinkForSeasideComponentOn: "! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderProcessTypeComboOn: html
	| definitionsNames |

	definitionsNames  := (BpmProcessDefinition getAllVersionsIn: (self searchValueAt: 'application' ifAbsent: [''])) collect: [:each | each processName].

	html label 
		attributeAt: 'for' put: 'processType';
		with: ('Process Type' translateFor: self session user).

	html select "Process Definition List"
		attributeAt: 'id' put: 'processType';
		list: self viewAllArray, definitionsNames
"(lateralCollection collect: [:each | each formProcessDefinition name]) asSet asSortedCollection";
		onChange: 'submit()';
		callback: [:value | self registerProcessType: value];
		selected: (self searchValueAt: 'process-type' ifAbsent: ['']).! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	self searchPanelIsRegular 
	ifTrue: [self renderSearchRegularPanelOn: html]
	ifFalse: [self renderSearchCategoriesPanelOn: html].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSearchCategoriesPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html legend class: 'top-search-legend'; with: ('Search Task' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'categotyLabel'; with: ('Category Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'categotyLabel'; callback: [:value | self addSearchValue: value named: 'category-name'].
			].
			self renderCategoriesListOn: html.
			html div id: 'top-search-filters-one'; with: [
				html submitButton 
					style: 'margin-top: 25px';
					callback: [self searchMatchingCategories]; 
					with: ('Search' translateFor: self session user).].
		].
].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSearchRegularPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html legend class: 'top-search-legend'; with: ('Search Task' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'processId'; with: ('Process Id' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'processId'; callback: [:value | self addSearchValue: value named: 'id'].].
			html div class: 'top-search-div'; with: [self renderApplicationComboOn: html].
			html div class: 'top-search-div'; with: [self renderProcessTypeComboOn: html].
			html div class: 'top-search-div'; with: [self renderFormDefinitionComboOn: html].
			html div class: 'top-search-div'; with: [self renderFormFieldComboOn: html].
			self renderFilterFields 
			ifTrue: [self renderFilterValuesAndButtonOn: html]
			ifFalse: [self renderSearchSubmitButtonOn: html]
			"self renderButtonWithoutFilters ifTrue: [self renderSearchSubmitButtonOn: html]. "
		].
	]! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSearchSubmitButtonOn: html
	| styleOption |

	styleOption := self renderFilterFields ifFalse: ['margin-top: 20px;'] ifTrue: [''].

	html div id: 'top-search-filters-one';
		style: styleOption;
		with: [
			html submitButton 
				class: '';
				callback: [self searchMatchingProcesses]; 
				with: ('Search' translateFor: self session user).
		]! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSeasideFormLinkIconOn: html for: aBpmSeasideTaskInstance

	"a granted user with edit permission"
	(aBpmSeasideTaskInstance isGrantedUser: self session user) 
	ifTrue: [^self createSeasideLinkOn: html for: aBpmSeasideTaskInstance].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderSwitchWindowOn: html

	html div id: 'top-search-switch-icon'; with: [
		html anchor 
			callback: [searchPanelName := (searchPanelName = #search) ifTrue: [#categories] ifFalse: [#search]];
			with: [
				html div with: [
					html image url: (SEWAFIconLibrary / #ezswitchuser16Png); 
						altText: ('Switch Window' translateFor: self session user); 
						title: ('Switch Window' translateFor: self session user).
				].
		].
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionActionsOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance isTask ifFalse: [^self].

	aBpmArtifactInstance renderHtmlOn: html for: self.

	(aBpmArtifactInstance isSubprocess not and: [aBpmArtifactInstance isDone not])
		ifTrue: [self renderCloseAndSendFormOn: html for: aBpmArtifactInstance.].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionDataOn: html for: aBpmArtifactInstance

	html anchor class: 'process-transition-icon-collapse';
		callback: [self switchOpenCloseTransition: aBpmArtifactInstance]; 
		with: [html image url: (SEWAFIconLibrary / (self collapseIconFor: aBpmArtifactInstance));
								title: (self collapseTitleFor: aBpmArtifactInstance);
								altText: (self collapseTitleFor: aBpmArtifactInstance)].

	html header with: [html strong: aBpmArtifactInstance printFormLargeNameForWebButton].
	html header with: [html strong: ('Task Data' translateFor: self session user)].

	((self displayModeFor: aBpmArtifactInstance) = #collapsed) ifTrue: [^self].

	aBpmArtifactInstance isTask 
	ifTrue: [^self renderTransitionFormDataOn: html for: aBpmArtifactInstance].

	aBpmArtifactInstance isSubprocessDefinition
	ifTrue: [^self renderTransitionSubProcessDataOn: html for: aBpmArtifactInstance].

	^self renderTransitionGatewayDataOn: html for: aBpmArtifactInstance! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionFormDataOn: html for: aBpmArtifactInstance

	self renderFormDataOn: html for: aBpmArtifactInstance.

	self renderTransitionSummaryOn: html for: aBpmArtifactInstance.
	self renderTransitionActionsOn: html for: aBpmArtifactInstance.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionGatewayDataOn: html for: aBpmArtifactInstance

	aBpmArtifactInstance triggeredGateway ifNotNil: [:gateway |
		gateway outgoingTransitions do: [:transition |  
			html div class: 'transition-data'; with: [
				html strong with: [html span with: ('Condition' translateFor: self session user)].
				html strong with: [html output with: transition getStartConditionsString]].
			html div class: 'transition-data'; with: [
				html strong with: [html span with: ('Next Form' translateFor: self session user)].
				html strong with: [html output with: transition endFormName]].
		]
	].! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionSubProcessDataOn: html for: aBpmArtifactInstance

	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('User' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance getUserName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('State' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: (aBpmArtifactInstance printState translateFor: self session user)]].
	"html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Previous Form' translateFor: self session user)].
		html strong with: [html output with: (anOrbeonFormTransition startFormName translateFor: self session user)]]."
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Form to Fill' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance getDefinitionName]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Initial Date' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance creationTime]].
	html div class: 'transition-data'; with: [
		html strong with: [html span with: ('Not implemented' translateFor: self session user)].
		html strong with: [html output "for: 'searchFields';" with: aBpmArtifactInstance creationTime]].

	self renderTransitionSummaryOn: html for: aBpmArtifactInstance.
	self renderTransitionActionsOn: html for: aBpmArtifactInstance.! !

!WAOrbeonProcessBrowser methodsFor: 'process' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTransitionSummaryOn: html for: aBpmArtifactInstance

	html header with: [html strong: (aBpmArtifactInstance summaryTitle translateFor: self session user)].

	aBpmArtifactInstance getSummaryFieldsValues keysAndValuesDo: [:key :value | 
		html div class: 'transition-data'; with: [
			html strong with: [html span with: key].
			html strong with: [html output with: value]]].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
renderTwoFitersOn: html

	html label 
		attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; 
		with: ('Start Value' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'filterOne';
		callback: [:value | self addSearchValue: value named: 'field-value'];
		with: (self searchValueAt: 'field-value' ifAbsent: ['']).
	html label 
		attributeAt: 'for' put: 'filterTwo';
		class: 'search-section-float'; 
		with: ('End Value' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'filterTwo';
		callback: [:value | self addSearchValue: value named: 'field-value-2'];
		with: (self searchValueAt: 'field-value-2' ifAbsent: ['']).

	self renderSearchSubmitButtonOn: html.! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
searchByProcessId
	| id |

	id  := self searchValueAt: 'id' ifAbsent: [''].

	searchResult := self getIterationCollection select: [:each | each processId printString = id].

	selectedLateralItem := nil.
	"selectedTransition := nil."

	self removeSearchValueNamed: 'id'! !

!WAOrbeonProcessBrowser methodsFor: 'categories' stamp: 'BrunoBB 08/03/2016 05:32'!
searchMatchingCategories

	categories := (BpmProcessInstanceCategory getCategoriesFor: self session user) select: [:each | 
		(self searchValueAt: 'category-name' ifAbsent: ['']) match: each name].! !

!WAOrbeonProcessBrowser methodsFor: 'search area' stamp: 'BrunoBB 08/03/2016 05:32'!
searchMatchingProcesses
	"Answer a collection of <OrbeonProcessAssignment> that match the search criteria in receiver's web interface.
	The fast search performed against a field name and a field value in a Form (<formName>, <fieldName> and <fieldValue>). 
	If these values are not specified then answer a collection of <OrbeonProcessAssignment> for the process name <procName> in application <appName>"
	| appName procName formName fieldName fieldValue fieldValue2 |

	searchApplied := true.
	(self hasSearchValueAt: 'id') ifTrue: [^self searchByProcessId].

	selectedLateralItem := nil.

	appName := self searchValueAt: 'application' ifAbsent: [''].
	procName := self searchValueAt: 'process-type' ifAbsent: [''].
	formName := self searchValueAt: 'form-type' ifAbsent: ['']. (formName = self viewAllText) ifTrue: [formName := ''].
	fieldName  := self searchValueAt: 'field-name' ifAbsent: [''].
	fieldValue  := self searchValueAt: 'field-value' ifAbsent: [''].
	fieldValue2 := self searchValueAt: 'field-value-2' ifAbsent: [''].

	(formName isEmpty and: [fieldName isEmpty and: [fieldValue isEmpty]]) 
	ifTrue: [^self getAllAssignmentsFor: procName in: appName].

	searchResult := self isRangeSearch
		ifFalse: [BpmProcessDefinition getAssignmentsIn: appName processName: procName formName: formName fieldName: fieldName withValue: fieldValue]
		ifTrue: [BpmProcessDefinition getAssignmentsIn: appName processName: procName formName: formName fieldName: fieldName initialValue: fieldValue endValue: fieldValue2].

	searchResult := self modeIsFinishedTasks 
		ifFalse: [searchResult reject: [:each | each hasFinalized]] 
		ifTrue: [searchResult select: [:each | each hasFinalized]]! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
seasideK
	^seasideK! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
seasideK: newValue
	seasideK := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
selectedLateralItem: newValue
	| oldAssignment |

	oldAssignment := selectedLateralItem.
	selectedLateralItem := newValue.

	(newValue notNil and: [oldAssignment ~~ selectedLateralItem])
	ifTrue: [self setTransitionsHeight].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
setTransitionsHeight

	transitionsHeight := Dictionary new.

	self getAllTasks do: [:each | 
		self session user transitionDisplayModeIsExpanded
		ifTrue: [transitionsHeight at: each put: #expanded]
		ifFalse: [transitionsHeight at: each put: #collapsed]].

	^transitionsHeight! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 08/03/2016 05:32'!
storeProcessDefinition: aBpmProcessInstance onZip: aZipArchive withFile: aGsFile
	|  stream member |

	stream := RWBinaryOrTextStream on: String new. 
	member := aZipArchive 
						addString: (self xmlHeader, (aBpmProcessInstance generateProcessMapFor: self session user) prettyPrinted) 
						as: (aBpmProcessInstance processName, '.xpdl').

	member desiredCompressionMethod: ZipArchive compressionDeflated. 

	aZipArchive writeTo: stream. 
	aGsFile nextPutAll: stream contents.

	aBpmProcessInstance subprocesses do: [:each | self storeProcessDefinition: each onZip: aZipArchive withFile: aGsFile].! !

!WAOrbeonProcessBrowser methodsFor: 'other' stamp: 'BrunoBB 08/03/2016 05:32'!
switchOpenCloseTransition: aBpmArtifactInstance

	((transitionsHeight includesKey: aBpmArtifactInstance) and: [(transitionsHeight at: aBpmArtifactInstance) = #expanded])
	ifTrue: [transitionsHeight at: aBpmArtifactInstance put: #collapsed]
	ifFalse: [transitionsHeight at: aBpmArtifactInstance put: #expanded]! !

!WAOrbeonProcessBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 08/03/2016 05:32'!
transitionsHeight
	^transitionsHeight! !

!WAOrbeonProcessBrowser methodsFor: 'Updating' stamp: 'BrunoBB 08/03/2016 05:32'!
transitionsHeight: newValue
	transitionsHeight := newValue! !

!WAOrbeonProcessBrowser methodsFor: 'export' stamp: 'BrunoBB 08/03/2016 05:32'!
xmlHeader

	^'<?xml version="1.0" encoding="utf-8"?>'! !

SEWAFApplicationPortal subclass: #WAProcessUserPortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 07/21/2016 10:07'!
applicationIcon

	^SEWAFIconLibrary / #documentflowchart32Png! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:29'!
applicationName

	^'Form Flow'! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:23'!
getAssignmentComponentClassFor: anOrbeonFormUser
	"Answer the class to use to display User Process Assginments.
	- Can be linked (in a different web page of Smalltalk application).
	- Can be embedded (in the same we page of Smalltalk application)"

	anOrbeonFormUser userOptions orbeonWebIsLinked ifTrue: [^WALinkedProcessBrowser].

	^WAEmbeddedProcessBrowser! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:23'!
initialize

	super initialize.

	subTabChanged := false.

	self initializeNavigation.! !

!WAProcessUserPortal methodsFor: 'top menu' stamp: 'BrunoBB 07/21/2016 10:20'!
initializeNavigation
	| subMenu1 subMenu2 subMenu3 subMenu4 |

	navigation := SewafPortalMenu new iconLibrary: SEWAFIconLibrary.
	subMenu1 := (SewafSubMenuItem label: 'My Processes' icon: #worksinprogress32Png)
		addItem: (SewafCommandItem label: 'Current Processes' command: #showCurrentProcess);
		addItem: (SewafCommandItem label: 'Finished Processes' command: #showFinishedProcess);
		addItem: (SewafCommandItem label: 'Process Categories' command: #showProcessCategories);
		yourself.
	subMenu2 := (SewafSubMenuItem label: 'Unassigned Tasks' icon: #folderscheduledtasks32Png)
		addItem: (SewafCommandItem label: 'View Unassigned Tasks' command: #showUnassignedTasks);
		yourself.
	subMenu3 := (SewafSubMenuItem label: 'Create Process' icon: #processadd32Png)
		addItem: (SewafCommandItem label: 'Available Processes' command: #showAvailableProcesses);
		addItem: (SewafCommandItem label: 'Granted Tasks' command: #showGrantedTasks);
		yourself.
	subMenu4 := (SewafSubMenuItem label: 'User Preferences' icon: #applicationsettings32Png)
		addItem: (SewafCommandItem label: 'Change Password' command: #showChangePassword);
		addItem: (SewafCommandItem label: 'Display Preferences' command: #showDisplayPreferences);
		addItem: (SewafCommandItem label: 'Set Language' command: #showLanguageConfiguration);
		yourself.
	navigation addItem: subMenu1;
		addItem: subMenu2;
		addItem: subMenu3;
		addItem: subMenu4.! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
logout

	self session logout.	
	self session unregister.
	self requestContext redirectTo: (self getGemStoneServerConfiguration gemstoneIP, '/orbeonProcess')! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 03/06/2016 14:03'!
selectedLateralItem: anObject

	arena ifNotNil: [arena selectedLateralItem: anObject].! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/12/2016 14:10'!
showAvailableProcesses

	^(arena class == WAOrbeonNewProcessBrowser)
	ifTrue: [arena setParent: self]
	ifFalse: [WAOrbeonNewProcessBrowser parent: self]! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 06/12/2016 14:33'!
showChangePassword

	^(arena class == WABpmUserChangePassword)
	ifTrue: [arena]
	ifFalse: [WABpmUserChangePassword parent: self]! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 04/17/2016 17:58'!
showCurrentProcess

	^self showCurrentProcess: self session user getCurrentAssigments asArray! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 03/06/2016 12:25'!
showCurrentProcess: anOrderedCollection
	| subComponent |

	(arena isKindOf: WAOrbeonProcessBrowser)
	ifTrue: [
		(arena mode = #normal) ifFalse: [arena searchApplied: false].
		arena mode: #normal.
		^arena parent: self collection: anOrderedCollection].

	subComponent := (self getAssignmentComponentClassFor: self session user) 
				parent: self collection: anOrderedCollection.
	
	subComponent mode: #normal; searchApplied: false.

	^subComponent! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 05/16/2016 11:41'!
showDisplayPreferences

	^WABpmUserPreference new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 07/06/2015 12:57'!
showFinishedProcess
	| subComponent |

	(arena isKindOf: WAOrbeonProcessBrowser)
	ifTrue: [
		(arena mode = #finished) ifFalse: [arena searchApplied: false].
		arena mode: #finished.
		^arena parent: self collection: OrderedCollection new"self session user finishedAssignments asArray"].

	subComponent := (self getAssignmentComponentClassFor: self session user) 
			parent: self collection: OrderedCollection new "self session user pendingAssignments asArray".

	subComponent mode: #finished; searchApplied: false.

	^subComponent! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 05/16/2016 11:10'!
showGrantedTasks

	(arena isKindOf: WAOrbeonGrantedTransitionManager)
	ifTrue: [^arena].

	^WAOrbeonGrantedTransitionManager parent: self! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 03/15/2016 10:41'!
showLanguageConfiguration

	^WASetUserLanguage new! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 07/05/2015 13:05'!
showProcessCategories

	(arena isKindOf: WAOrbeonProcessCategoryManager)
	ifTrue: [^arena].

	^WAOrbeonProcessCategoryManager parent: self! !

!WAProcessUserPortal methodsFor: 'sub components' stamp: 'BrunoBB 12/08/2015 08:46'!
showUnassignedTasks

	"^WAFreeTransitionBagBrowser new"

	(arena class == WABpmUnassignedTaskBrowser)
	ifFalse: [^WABpmUnassignedTaskBrowser new].

	^arena! !

!WAProcessUserPortal methodsFor: 'style' stamp: 'BrunoBB 08/04/2016 10:07'!
style

^'/* Smart Devices*/
@media (max-width: 800px) {                  
   .smart-hide-width {
      display: none !!important;
   }
}
@media (max-height: 450px) {                  
   .smart-hide-height {
      display: none !!important;
   }
}
/* NEW CSS - REFACTORIZED */
/* START: HTML GENERAL */
body, html, main {
	margin: 0;
	width: 100%;
	height: 100%;
	overflow-y: hidden;
	background-color: #BCBCBC;
}
#screen-all {
	height: 100%;
}
/* END: HTML GENERAL */
/* START: TOP AREA */
#top-area {
	display: inline-flex;
	width: 100%;
	background-color: gray;
	padding-top: 2px;
}
#top-app-icon-area {
	display: inline-flex;
	padding-left: 10px;
	width: 20%;
}
#top-app-icon-area h1{
	margin-top: 5px;
	color: gainsboro;
}
#top-app-name {
	font-size: 30px;
	color: gainsboro;
}
#top-app-version-name {
	font-size: 14px;
}
#top-logout a {
	text-decoration: none;
}
#top-logout output {
	font-size: 90%;
}
#top-menu-area {
	width: 80%;
	margin-top: 5px;
}
.top-menu-item {
	float: left;
	margin-left: 5%;
}
.top-menu-item a {
	color: white;
	text-decoration: none;
}
.top-menu-item a output {
	font-size: 120%;
}
.top-menu-item img {
	display: block;
	margin-left: auto;
	margin-right: auto;
}
.top-menu-item-triangle {
	border-style: solid;
	border-width: 0px 10px 10px;
	border-color: transparent transparent #D3D3D3;
	color: #FFF;
	width: 0px;
	height: 0px;
	margin-left: auto;
	margin-right: auto;
}
#top-submenu-area {
	height: 40px;
	background-color: lightgray;
}
.top-area-close-icon {
	float: right;
	margin-top: 3px;
	margin-right: 5px;
}
.top-sub-item-selected output {
	font-family: Times New Roman;
	font-size: 20px;
	color: rgb(64, 64, 64);
}
.top-sub-item-selected a, .top-sub-item-unselected a {
	text-decoration: none;
}
.top-sub-item-selected, .top-sub-item-unselected {
	float: left;
	padding-top: 10px;
	margin-left: 10px;
	margin-right: 30px;
}
.top-sub-item-unselected output {
	font-family: Times New Roman;
	font-size: 20px;
	color: #808080;
}
.top-sub-item-selected, .top-sub-item-unselected output:hover {
	color: rgb(64, 64, 64);
}
/* END: TOP AREA */
/* START: BOTTOM AREA */
/* END: BOTTOM AREA */
/* START: COMPONENT AREA */
#component-area {
	background-color: #BCBCBC;
	height: 100%;
}
#component-area hr {
	margin-top: 0px;
	margin-bottom: 0px;
}
/*START: SEARCH AREA*/
#top-search-area {
	width: 100%;
	display: inline-flex;
}
.top-search-area-box-shadow {
	box-shadow: 2px 2px 2px 0px rgba(11, 10, 10, 0.8);
}
#top-search-show-hide-area {
	display: inline-flex;	
}
#top-search-switch-icon {
	display: inline-flex;
	float: right;
	margin-top: -25px;
}
#top-search-area form {
	width: 100%;
}
#top-search-area form fieldset {
	border-radius: 6px;
	margin-bottom: 0px;
	padding-bottom: 5px;
	border: none;
}
#top-search-area form fieldset label {
	margin-right: 10px;
}
#top-search-area form fieldset input[type="text"], 
#top-search-area form fieldset select {
	border-radius: 6px;
	margin-right: 20px;
	border-color: darkgray;
	width: 100%;
}
.top-search-div {
	float: left;
	width: 200px;
	margin-right: 15px;
}
.top-search-legend {
	font-weight: bold;
	text-decoration: underline;
}
#top-search-filters-one {
	display: inline-block;
	width: 200px;
	margin-top: -5px;
}
#top-search-filters-two {
	display: inline-block;
	width: 200px;
	margin-top: -15px;
}
#top-search-filters-one input {
	border-radius: 6px;
	margin-right: 20px;
	border-color: #A9A9A9;
}
#top-search-filters-two input {
	border-radius: 6px;
	margin-right: 20px;
	border-color: #A9A9A9;
}
.top-search-vertical-line {
	width: 8px;
	background-color: lightgray;
	float: left;
	margin-right: 10px;
}
/*END: SEARCH AREA*/
/*START: INNER COMPONENTS*/
.artifact-definition {
    padding: 5px 15px 15px;
    float: left;
    margin: 10px;
    border-radius: 10px;
    background-color: #868686;
    width: 20%;
    height: 20%;
    overflow-y: auto;
}
#artifact-definitions {
    display: inline-block;
	width: 100%;
}
#assignation-close-form form fieldset {
	border: 0px;
}
.assignation-title {
	font-size: 20px;
	text-align: center;
	margin-bottom: 15px;
}
.category-circle {
	width: 20px;
	height: 20px;
	border-radius: 10px;
	float: left;
	margin-bottom: 3px;
	margin-left: 2px;
	text-align: center;
}
.category-label {
	float: right;
	text-decoration: none;
	color: white;
	border-radius: 10px;
	padding-left: 5px;
	padding-right: 5px;
	margin-left: 5px;
	margin-right: 5px;
}
.centered-forms {
	margin-left: 1%;
	margin-right: 2%;
	margin-top: 1%;
}
.centered-forms-width38 {
	width: 38%;
}
.centered-forms form { 
	border-radius: 10px;
	border-style: inset;
	background-color: #7A7557;
	padding: 5px;
	border-width: 2px;
	width: 100%;
}
.centered-forms form fieldset {
	border: none;
} 
.centered-forms form input[type="text"]{ 
	border-radius: 10px;
	border-style: inset;
	width: 350px;
	margin-bottom: 5px;
}
.centered-forms form input[type="submit"] { 
	border-radius: 10px;
	width: 150px;
	border-right: 10px;
	margin-left: 3%;
	margin-right: 3%;
	margin-top: 1%;
}
.centered-forms form input[type="file"] { 
	border-radius: 10px;
	width: 400px;
	border-right: 10px;
	margin-top: 10px;
	margin-bottom: 5px;
}
.centered-forms form label { 
	display: block;
	margin-top: 10px;
}
.centered-forms form select { 
	border-radius: 10px;
	border-style: inset;
	display: block;
	width: 350px;
	margin-bottom: 10px;
}
.centered-forms form p { 
	margin-top: 10px;
	font-size: 20px;
	font-style: italic;
	text-align: right;
}
.centered-forms legend {
	text-align: center;
	font-size: 20px;
	color: black;
}
.centered-forms output {
	text-align: center;
	font-size: 16px;
	color: #EADDDD;
}
.centered-forms ul {
	border-radius: 15%;
	background-color: #F5F5DC;
}
.free-selected-process {
	float: right;
}
#free-tasks-list {
	overflow-y: auto;
}
.free-tasks-list-hide-top {
	height: 86%;
}
.free-tasks-list-show-top {
	height: 77%;
}
#free-tasks-list ul {
	list-style-type: none;
	margin-top: 0px;
}
#granted-transitions {
	width: 60%;
	margin-left: auto;
	margin-right: auto;
}
.hide-lateral-left-list {
	float: left;
}
.inform-box {
	padding: 10px;
	border-radius: 10px;
	border: 1px solid;
	color: rgb(205, 10, 10);
	background-color: rgb(254, 241, 236);
	margin-top: 10px;
	margin-left: 15px;
	margin-bottom: 15px;
	width: inherit;
	margin-right: 20px;
}
#item-customized-component {
	overflow-y: scroll;
	position: relative;
	bottom: 0px;
}
.item-customized-component-hide-top {
	height: 74%;
}
.item-customized-component-show-top {
	height: 65%;
}
.lateral-left-list {
	width: 19.5%;
	display: inline-block;
	height: 100%;
	font-size: 90%;
	box-shadow: 2px 2px 2px 0px rgba(11, 10, 10, 0.8) inset;
}
.lateral-left-list ul {
	list-style-type: none;
	padding-left: 2px;
}
.lateral-left-list a {
	text-decoration: none;
	color: black;
}  
.lateral-left-list ul li {
	margin-bottom: 10px;
}
.lateral-left-list-icon {
	width: 32px;
	float: left;
	padding-left: 5px;
	padding-top: 5px;
}
.lateral-left-list-item-selected {
	background-color: beige;
	border-radius: 10px;
	padding-left: 10px;
}
.lateral-left-list-item-unselected {
}
.lateral-left-list-item-summary-data {
	display: inline-block;
	color: rgb(37, 46, 146);
}
.lateral-left-list-item-summary-data output {
	display: block;
	margin-left: auto;
	margin-right: auto;
}
.lateral-left-list-item-title-selected {
	font-size: 150%;
}
.lateral-left-list-item-title-unselected {
	font-size: 150%;
}
.lateral-right-component-additional-data {
	text-align: center;
}
.lateral-right-component-additional-data span {
	font-style: italic;
	margin-right: 5px;
	margin-left: 15px;
	color: #8A8A59;
}
.lateral-right-component-additional-data output {
	color: darkblue;
}
.lateral-right-component {
	height: 100%;
	float: right;
	background-color: #BCBCBC;
}
.lateral-right-component-description {
	background-color: #E4E49E;
	padding-bottom: 15px;
	margin-left: 2px;
    margin-top: 2px;
    margin-right: 2px;
}
.lateral-right-component-main-data {
	font-size: 150%;
	text-align: center;
	padding-top: 1px;
}
.lateral-right-component-main-data a {
	float: right;
}
.lateral-right-component-width80 {
	width: 80.5%;
}
.lateral-right-component-width100 {
	width: 100%;
}
.lateral-right-component-secondary-data {
	text-align: center;
}
.lateral-right-component-secondary-data span {
	font-style: italic;
	margin-right: 5px;
	margin-left: 15px;
	color: #8A8A59;
}
.lateral-right-component-secondary-data output {
	color: darkblue;
}
.list-lateral-element {
	width: 90%;
}
.list-lateral-element-custom {
	float: right;
	width: 10%;
}
.list-lateral-item {
	display: flex;
	margin-bottom: 5px;
	margin-top: 5px;
}
.monitor-list-icon {
	float: left;
	display: inline;
}
.monitor-list-icon-2 {
	float: right;
	display: inline;
}
.monitor-list-icon-height75 {
	height: 75px;
}
.monitor-list-icon-height90 {
	height: 110px;
}
.monitor-list-item-data {}
.monitor-list-item-data span {
	font-style: italic;
}
.monitor-list-item-data output {
	color: #231D81;
	margin-left: 10px;
	float: right;
}
.monitor-list-item-summary {
	display: inline-block;
    margin: 20px;
    padding: 20px;
    background-color: white;
    border-radius: 10px;
}
.monitor-list-item-summary span {
	font-style: italic;
}
.new-process-options {
    width: 50%;
    float: left;
}
#new-process-options-form {
	display: inline-flex;
}
#new-process-list  ul {
	list-style-type: none;
	margin-top: 0px;
}
#orbeon-form-frame {
	height: 400px;
} 
#orbeon-form {
	height: 100%;
}
#orbeon-form iframe {
	width: 100%;
	height: 100%;
}
#process-definition {
	height: 100%;
	box-shadow: 2px 2px 2px 0px rgba(11, 10, 10, 0.8) inset;
}
#process-assigment-transitions {
	margin-left: 10px;
	margin-top: 10px;
	overflow-y: auto;
	height: 440px;
}
.process-transition-icon-collapse {
	float: right;
}
.process-transition-finished {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	background-color: #8CBD80;
	width: 28%;
	height: 60%;
	overflow-y: auto;
	box-shadow: 0px 0px 3px 0px rgba(11, 10, 10, 0.8);
}
.process-transition-gateway {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	background-color: #ADADAD;
	width: 28%;
	height: 60%;
	overflow-y: auto;
}
.process-transition-running {
	padding: 15px;
	padding-top: 5px;
	float: left;
	margin: 10px 10px 10px 10px;
	border-radius: 25px;
	width: 28%;
	height: 60%;
	overflow-y: auto;
	background-color: #80A0BD;
	box-shadow: 0px 0px 3px 0px rgba(11, 10, 10, 0.8);
}
.process-transition-collapsed {
	height: 1%;
}
.process-transition-expanded {
	height: 60%;
}
.table-search-element form fieldset, .table-search-element fieldset{
	border: 0px none;
}
.table-search-element form fieldset label,  .table-search-element fieldset label {
	display: inherit;
	text-align: left;
	font-size: 80%;
}
.table-search-element form fieldset input[type="text"],  .table-search-element fieldset input[type="text"]{
	border-radius: 6px;
	margin-right: 2px;
}
.table-search-element form fieldset input[type="submit"], .table-search-element fieldset input[type="submit"]{
    margin-top: 0px;
}
.transition-data span {
	margin-right: 20px;
	font-style: italic;
	color: #565656;
    display: inline-table;
}
.transition-data output  {
	color: rgb(50, 51, 122);
	float: right;
}
.unique-centered-table {
	margin-left: auto;
	margin-right: auto;
	border: 2px solid #000;
	border-radius: 10px;
	margin-top: 30px;

}
.unique-centered-table-width30 {
	width: 30%;
}
.unique-centered-table-width70 {
	width: 70%;
}
.unique-centered-table  table {
	width: 100%;
}
.unique-centered-table fieldset {
	border: 0px none;
	margin-left: auto;
	margin-right: auto;
	width: 150px;
	margin-top: 20px;
}
.unique-centered-table fieldset  input {
	border-radius: 10px
}
.unique-wide-list-icon {
	width: 2.5%;
	float: left;
	display: inline;
}
.unique-wide-list-icon-height75 {
	height: 75px;
}
.unique-wide-list-icon-height90 {
	height: 110px;
}
.unique-wide-list-item-data {}
.unique-wide-list-item-data span {
	font-style: italic;
}
.unique-wide-list-item-data output {
	color: #231D81;
	margin-left: 10px;
}
.unique-wide-list-item-summary {}
.unique-wide-list-item-summary span {
	font-style: italic;
}
/*END: INNER COMPONENTS*/
/* END: COMPONENT AREA */
/*   ESTILES IN TEST   */
.batch {
	border-radius: 5px;
	padding: 5px;
	background: beige;
	margin-right: 2px;
	margin-left: 2px;
	display: inline-block;
    text-decoration: none;
    color: black;
}
.batch-div-bottom {
	margin-top: -8px;
	margin-left: 15px;
}
.batch-div-bottom-with-buttom {
	margin-top: -65px;
	margin-left: 25px;
}
.batch-div-lateral-top {
	margin-top: 10px;
	margin-bottom: -8px;
	margin-left: 5px;
}
.centered-unique-form {
	color: black;
	background-color: #BCBCBC;
	font-size: 18px;
	font-style: normal;
	border-radius: 5px;
	border: 1px solid #BCBCBC;
	border-width: 1px 1px 3px;
	margin-bottom: 10px;
	padding: 10px;
}
.centered-unique-form form {
	max-width: 350px;
	margin: 10px auto;
	padding: 10px 20px;
	background: #898a8a;
	border-radius: 8px;
}
.centered-unique-form fieldset {
	margin-bottom: 5px;
	border: none;
}
.centered-unique-form h1 {
	margin: 0 0 30px 0;
	text-align: center;
}
.centered-unique-form input[type="text"],
.centered-unique-form input[type="password"], 
.centered-unique-form input[type="date"],
.centered-unique-form input[type="datetime"], 
.centered-unique-form input[type="email"],
.centered-unique-form input[type="number"], 
.centered-unique-form input[type="search"],
.centered-unique-form input[type="tel"], 
.centered-unique-form input[type="time"],
.centered-unique-form input[type="url"], 
.centered-unique-form textarea, 
.centered-unique-form select {
	background: rgba(255,255,255,0.1);
	font-size: 16px;
	height: auto;
	margin: 0;
	outline: 0;
	width: 100%;
	background-color: white;
	color: black;
	box-shadow: 0 1px 0 rgba(0,0,0,0.03) inset;
	margin-bottom: 10px;
}
.centered-unique-form input[type="radio"], 
.centered-unique-form input[type="checkbox"] {
	margin: 0 4px 8px 0;
}
.centered-unique-form select {
	padding: 6px;
	border-radius: 2px;
}
.centered-unique-form label {
	display: block;
	margin-bottom: 8px;
}
.centered-unique-form label.light {
	font-weight: 300;
	display: inline;
}
/* BASIC BLOCK STYLES */
.display-block {
	display: block;
}
.display-inline-block {
	display: inline-block;
}
.float-left {
	float: left;
}
.float-none {
	float: none;
}
.float-right {
	float: right;
}
.height180 {
	height: 180px;
}
.height250 {
	height: 250px;
}
.height300 {
	height: 300px;
}
.margin-left-5px {
	margin-left: 5px;
}
.margin-right-20per {
	margin-right: 20%;
}
.margin-top-20px {
	margin-top: 20px;
}
.margin-top-15px {
	margin-top: 15px;
}
.margin-top-10px {
	margin-top: 10px;
}
.margin-bottom-15px {
	margin-bottom: 15px;
}
.margin-bottom-10px {
	margin-bottom: 10px;
}
.underline {
	text-decoration: underline;
}
.no-underline {
	text-decoration: none;
}
.width-50per {
	width: 50%;
}
/* RIGHT LATERAL TABLE STYLES */
.default-gray-table table {
	color:black;
	font-size:18px;
	background:#898a8a;
	margin-top: 20px;
	margin-bottom: 10px;
	margin-left: 10px;
	margin-right: 20px;
	border:#ccc 1px solid;

	-moz-border-radius:3px;
	-webkit-border-radius:3px;
	border-radius:3px;

	-moz-box-shadow: 0 1px 2px #d1d1d1;
	-webkit-box-shadow: 0 1px 2px #d1d1d1;
	border-radius: 10px;
	padding-bottom: 2px;
	padding-left: 2px;
	padding-right: 2px;
}
.default-gray-table table a:link {
	color: #666;
	font-weight: bold;
	text-decoration:none;
}
.default-gray-table table a:visited {
	color: #999999;
	font-weight:bold;
	text-decoration:none;
}
.default-gray-table table a:active,
.default-gray-table table a:hover {
	color: black;
	text-decoration:underline;
}
.default-gray-table table th {
	padding:10px 15px 5px 15px;
	background-color: #898a8a;
}
.default-gray-table table th:first-child {
	text-align: left;
	padding-left:20px;
}
.default-gray-table table tr:first-child th:first-child {
	-moz-border-radius-topleft:5px;
	-webkit-border-top-left-radius:5px;
	border-top-left-radius:5px;
}
.default-gray-table table tr:first-child th:last-child {
	-moz-border-radius-topright:3px;
	-webkit-border-top-right-radius:3px;
	border-top-right-radius:3px;
}
.default-gray-table table tr {
	text-align: center;
	padding-left:20px;
}
.default-gray-table table td:first-child {
	text-align: left;
	padding-left:20px;
	border-left: 0;
}
.default-gray-table table td {
	padding: 5px;
}
.default-gray-table table tr.even td {
	background: #f6f6f6;
	background: -webkit-gradient(linear, left top, left bottom, from(#f8f8f8), to(#f6f6f6));
	background: -moz-linear-gradient(top,  #f8f8f8,  #f6f6f6);
}
.default-gray-table table tr:last-child td {
	border-bottom:0;
}
.default-gray-table table tr:first-child td:first-child {
	-moz-border-radius-topleft:5px;
	-webkit-border-top-left-radius:5px;
	border-top-left-radius:5px;
}
.default-gray-table table tr:first-child td:last-child {
	-moz-border-radius-topright:5px;
	-webkit-border-top-right-radius:5px;
	border-top-right-radius:5px;
}
.default-gray-table table tr:last-child td:first-child {
	-moz-border-radius-bottomleft:5px;
	-webkit-border-bottom-left-radius:5px;
	border-bottom-left-radius:5px;
}
.default-gray-table table tr:last-child td:last-child {
	-moz-border-radius-bottomright:5px;
	-webkit-border-bottom-right-radius:5px;
	border-bottom-right-radius:5px;
}
.default-gray-table table tr:hover td {
	background: #f2f2f2;
	background: -webkit-gradient(linear, left top, left bottom, from(#f2f2f2), to(#f0f0f0));
	background: -moz-linear-gradient(top,  #f2f2f2,  #f0f0f0);	
}'! !

!WAProcessUserPortal methodsFor: 'other' stamp: 'BrunoBB 06/11/2016 14:05'!
versionName

	^'2016 q2 v3.1'! !

WASession subclass: #WABpmSession
	instanceVariableNames: 'user password rols'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWeb'!

!WABpmSession methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:20'!
isLoggedIn

    ^user isNil not! !

!WABpmSession methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:20'!
login: aString
    user := aString! !

!WABpmSession methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:20'!
logout
    user := nil! !

!WABpmSession methodsFor: 'Accessing' stamp: 'BrunoBB 02/24/2016 15:20'!
password

   "Return the value of the instance variable 'password'."
   ^password! !

!WABpmSession methodsFor: 'Updating' stamp: 'BrunoBB 02/24/2016 15:20'!
password: newValue

   "Modify the value of the instance variable 'password'."
   password := newValue! !

!WABpmSession methodsFor: 'Accessing' stamp: 'BrunoBB 02/24/2016 15:20'!
rols

   "Return the value of the instance variable 'rols'."
   ^rols! !

!WABpmSession methodsFor: 'Updating' stamp: 'BrunoBB 02/24/2016 15:20'!
rols: newValue

   "Modify the value of the instance variable 'rols'."
   rols := newValue! !

!WABpmSession methodsFor: 'other' stamp: 'BrunoBB 02/24/2016 15:20'!
user
    ^ user! !

!WABpmSession methodsFor: 'Updating' stamp: 'BrunoBB 02/24/2016 15:20'!
user: newValue

   "Modify the value of the instance variable 'user'."
   user := newValue! !
